//获取应用实例
const app = getApp();

Page({

  /**
   * 页面的初始数据
   */
  data: {
    roomId: '',

    myCanvasWidth:0,
    myCanvasHeight:0,
    myCanvasBackground:'0,0,0,0',

    currentBoardUserId: null,
    currentBoardId: null,

    isShowBoardSetting: false,
    isShowshaeTypeSetting: false,

    isShowOpenBoard: true,
    isShowCloseBoard: false,

    currentBoardColorIndex: 0,
    currentBoardWidth: wx.getSystemInfoSync().windowWidth,
    currentBoardHeight: 0,
    

    currentShapeTypeIndex: 0,
    currentShapeColorIndex: 2,
    currentLineWidth: 2,

    colorList: [
      {
        text: '白色',
        value: '255, 255, 255, 1'
      },
      {
        text: '红色',
        value: '255, 0, 0, 1'
      },
      {
        text: '黑色',
        value: '0, 0, 0, 1'
      },
      {
        text: '蓝色',
        value: '0, 0, 255, 1'
      },
      {
        text: '黄色',
        value: '255, 255, 0, 1'
      },
      {
        text: '绿色',
        value: '0, 255, 0, 1'
      }     
    ],


    shapeTypeList: [
      {
        text: '线',
        value: 2
      },
      {
        text: '折线',
        value: 5
      },
      {
        text: '箭头',
        value: 999
      },
      {
        text: '椭圆',
        value: 4
      },
      {
        text: '矩形',
        value: 3
      },
      {
        text: '填充矩形',
        value: 333
      },
      {
        text: '菱形',
        value: 11
      },
      {
        text: '对号',
        value: 13
      },
      {
        text: '固定箭头',
        value: 12
      },
      {
        text: '错号',
        value: 14
      },
      {
        text: '名字',
        value: 8
      },
      {
        text: '激光笔',
        value: 0
      }
    ]
  },
  //白板设置
  boardSettingClick: function(){
    var self = this;

    self.setData({
      isShowBoardSetting: !self.data.isShowBoardSetting,
      isShowShapeTypeSetting: false
    })
  },

  //画笔操作
  shapeTypeClick: function(){
    var self = this;
    self.setData({
      isShowShapeTypeSetting: !self.data.isShowShapeTypeSetting,
      isShowBoardSetting: false
    })
  },
 
  //打开白板
  openBoardClick: function(){
    var self = this;
    if(app.data.getAvdSDK.room.selfUser.boards.length > 0){
        var board = app.data.getAvdSDK.room.selfUser.boards[0];
        if(board && board.status == app.data.getAvdSDK.Enum.boardStatusEnum.close){
           self.createBoardHandle(board);
           app.data.getAvdSDK.room.selfUser.shareBoardById(board.id);
        }
    }else{
        var boardWidth = self.data.currentBoardWidth;
        var boardHeight = self.data.currentBoardHeight;
        var backgroundColor = self.data.colorList[self.data.currentBoardColorIndex].value;
        var backgroundImage = "https://aaaaaa/tmc/aa.png";
        var board = app.data.getAvdSDK.room.selfUser.createBoard(boardWidth, boardHeight, backgroundColor, backgroundImage,'',boardWidth,boardHeight);
        self.createBoardHandle(board);
    }
    self.setData({
       isShowOpenBoard: !self.data.isShowOpenBoard,
       isShowCloseBoard: true
   })
  },


  //关闭白板
  closeBoardClick: function(){
    var self = this;
    var board = app.data.getAvdSDK.room.selfUser.boards[0];
    if(board && board.status == app.data.getAvdSDK.Enum.boardStatusEnum.open){
      self.setData({
        isShowCloseBoard: !self.data.isShowCloseBoard,
        isShowOpenBoard: true
      })

      self.closeBoardHandle(board.id);
      app.data.getAvdSDK.room.selfUser.closeBoardById(board.id);
    }
  },


  //退会
  closeRoomClick: function(){
    var self = this;
    wx.showLoading({
      title: '退会中...',
      mask: true
    });
    var reason = 1; //退会原因
    if (app.data.getAvdSDK.room) {
      app.data.getAvdSDK.room.leave(reason).then(function() {
        var url = "../touch/touch";
        wx.reLaunch({
          url: url
        });
      });
    }
  },
 

  boardBgChange: function(e){
    this.setData({
      currentBoardColorIndex: e.detail.value
    })
    if(app.data.getAvdSDK.room.selfUser.boards[0]){
      app.data.getAvdSDK.room.selfUser.boards[0].updateBackgroundColor(this.data.colorList[e.detail.value].value);
      app.data.getAvdSDK.room.selfUser.updateBoard(app.data.getAvdSDK.room.selfUser.boards[0]);
    }
  },

  boardWidthChange(e){
    this.setData({
      currentBoardWidth: parseInt(e.detail.value)
    })
  },

  boardHeightChange(e){
    this.setData({
      currentBoardHeight: parseInt(e.detail.value)
    })
  },


  shapeTypeChange: function(e){
    var self = this;
    self.setData({
      currentShapeTypeIndex: e.detail.value
    });

    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
        var shapeTypeValue = self.data.shapeTypeList[self.data.currentShapeTypeIndex].value;
        if(shapeTypeValue == '999') {
            console.log('+++shapeTypeChange 双箭头')
            currentBoard.annotation.setShapeType(app.data.getAvdSDK.Enum.shapeTypeEnum.line);
            currentBoard.annotation.setArrowType(app.data.getAvdSDK.Enum.arrowTypeEnum.double);
        } else if(shapeTypeValue == '333') {
          console.log('+++shapeTypeChange 填充矩形')
            currentBoard.annotation.setShapeType(app.data.getAvdSDK.Enum.shapeTypeEnum.rect);
            currentBoard.annotation.setFillColor(app.data.getAvdSDK.Enum.fillTypeEnum.full);
        } else if(shapeTypeValue == '0') {
            console.log('+++shapeTypeChange 激光笔')
            currentBoard.annotation.startHlightPoint();
        } else {
          console.log('+++shapeTypeChange 其他画笔')

            currentBoard.annotation.setArrowType(app.data.getAvdSDK.Enum.arrowTypeEnum.none);
            currentBoard.annotation.setShapeType(shapeTypeValue);
            currentBoard.annotation.setFillColor(app.data.getAvdSDK.Enum.fillTypeEnum.none);
        }
    }
  },

  shapeColorChange: function(e){
    var self = this;
    self.setData({
      currentShapeColorIndex: e.detail.value
    });
    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
       var shapeColorValue = self.data.colorList[self.data.currentShapeColorIndex].value;
       currentBoard.annotation.setColor("rgba("+shapeColorValue+")");
    }
  },

  lineWidthChange(e){
    var self = this;
    this.setData({
      currentLineWidth: parseInt(e.detail.value)
    });
    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
      currentBoard.annotation.setLineWidth(self.data.currentLineWidth);
    }
  },


   //橡皮擦
  eraserClick: function(){
    console.log("+++eraserClick()");

    var self = this;
    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
      // TODO 设置橡皮擦宽高
       currentBoard.annotation.setEraserImageWidthAndHeight(32,32);
       currentBoard.annotation.setShapeType(app.data.getAvdSDK.Enum.shapeTypeEnum.eraser, '../resources/images/icon-eraser.png');
    }
  },

  mouseClick(){
    console.log("+++mouseClick()");
    var self = this;
    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    currentBoard.annotation.setShapeType(app.data.getAvdSDK.Enum.shapeTypeEnum.mouse);
  },
  
  clearShapeClick: function(){
     console.log("+++clearShapeClick()");

     var self = this;
     var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
     if(currentBoard) {
         currentBoard.annotation.clear();
     }
  },

  

  downloadClick: function(){
    var self = this;

    //将生成的canvas图片，转为真实图片
    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      canvasId: 'myCanvas',
      success: function (res) {
        let shareImg = res.tempFilePath;
        self.downloadHandle(shareImg);
      },
      fail: function (res) {
      }
    })
  },

  downloadHandle: function(shareImg){
    let self = this;

    //获取用户是否开启用户授权相册
    wx.getSetting({
      success(res) {
        // 如果没有则获取授权
        if (!res.authSetting['scope.writePhotosAlbum']) {
          wx.authorize({
            scope: 'scope.writePhotosAlbum',
            success() {
              wx.saveImageToPhotosAlbum({
                filePath: shareImg,
                success() {
                    wx.showToast({
                      title: '保存成功'
                    })
                },
                fail() {
                    wx.showToast({
                      title: '保存失败',
                      icon: 'none'
                    })
                }
              })
            },
            fail() {
              // 如果用户拒绝过或没有授权，则再次打开授权窗口
              //（ps：微信api又改了现在只能通过button才能打开授权设置，以前通过openSet就可打开，下面有打开授权的button弹窗代码）
             }
          })
        } else {
          // 有则直接保存
          wx.saveImageToPhotosAlbum({
            filePath: shareImg,
            success() {
              wx.showToast({
                 title: '保存成功'
              })
            },
            fail() {
              wx.showToast({
                title: '保存失败',
                icon: 'none'
              })
            }
          })
        }
      }
    })
  },



 chooseMouse: function() {
    var self = this;
    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
      currentBoard.annotation.setShapeType(app.data.getAvdSDK.Enum.shapeTypeEnum.mouse);
    }
    
  },

    //注册房间回调
  registerRoomCallback: function() {
      //console.log(new Date(), "+++registerRoomCallback()");
      app.data.getAvdSDK.room.addCallback(app.data.getAvdSDK.Enum.RoomCallback.user_join_notify, this.onUserJoinNotify);
      app.data.getAvdSDK.room.addCallback(app.data.getAvdSDK.Enum.RoomCallback.user_leave_notify, this.onUserLeaveNotify);
      app.data.getAvdSDK.room.addCallback(app.data.getAvdSDK.Enum.RoomCallback.leave_indication, this.onLeaveIndication);
      app.data.getAvdSDK.room.addCallback(app.data.getAvdSDK.Enum.RoomCallback.close_room_result, this.onCloseRoomResult);
      app.data.getAvdSDK.room.addCallback(app.data.getAvdSDK.Enum.RoomCallback.close_room_notify, this.onCloseRoomNotify);
  
      app.data.getAvdSDK.room.setRoomCallbackMonitorState2True();
  },



   /**
   * @desc 参会者加会回调
   * @param {Object} users － 参会者数组
   */
  onUserJoinNotify: function(users) {
    //console.log(new Date(), "+++onUserJoinNotify()");
    this.participantsHandle(users);
  },

  /**
   * @desc 参会者退会回调
   * @param {int} opt - 退会类型
   * @param {int} reason  - 退会原因
   * @param {Object} user - 退会用户
   */
  onUserLeaveNotify: function(opt, reason, user) {
    var self = this;
    console.log(new Date(), "+++onUserLeaveNotify(),reason:", reason, ",user:", user);
    if(user.boards.length > 0 ){
      self.closeBoardHandle();
    }
    //用户异常离会(用户心跳包超时掉线)
    if (reason == 812) {
      wx.showModal({
        title: '提示',
        content: '参会者已异常离会',
        showCancel: false,
        success(res) {
        }
      })
      return;
    } else {
      console.log(new Date(), "+++onUserLeaveNotify(),正常离会");
    }
  },

  /**
   * @desc 被踢出会议室
   * @param {Object} reason - 被踢原因
   * @param {Object} userId - 踢人的操作者
   */
  onLeaveIndication: function(reason, userId) {
    //console.log(new Date(), "+++onLeaveIndication()");
    var self = this;
    var user = app.data.getAvdSDK.room.getUser(userId);
    var userName = '';
    if (user != null) {
      userName = user.name;
    }

    if (reason == 804) { //同一个userid加会， 把前一个人踢下线
      wx.showModal({
        title: '退会提示',
        content: '您已在另一终端登陆，被踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else if (reason == 808) { //调用rest api接口把人踢下线
      wx.showModal({
        title: '退会提示',
        content: '您被' + userName + '踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else if (reason == 809) { //无授权 15分钟以后强制踢人
      wx.showModal({
        title: '退会提示',
        content: '无授权，试用时限到期，您被' + userName + '踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else {
      wx.showModal({
        title: '退会提示',
        content: '您已被主持人从会议中踢出',
        showCancel: false
      });
    }

    clearInterval(this.intervalTimer);

    setTimeout(function() {
      self.leaveRoom();
      return false;
    }, 5000);

  },

   /**
   * @desc 关闭会议回调结果
   * @param {int} result - 关闭结果
   * @param {String} description - 描述
   */
  onCloseRoomResult: function(result, description) {
    //console.log(new Date(), "+++onCloseRoomResult()");
    var self = this;
    if (result == 0) {
      self.leaveRoom();
      return false;
    } else {
      wx.showModal({
        title: '关闭会议提示',
        content: '关闭会议异常。原因：' + description + '[' + result + ']',
        showCancel: false
      });
    }
  },

   /**
   * @desc 收到主持人关闭房间通知，退出会议操作
   * @param {int} roomId - 房间ID
   * @param {int} reason  -关闭会议原因
   */
  onCloseRoomNotify: function(roomId, reason) {
    //console.log(new Date(), "+++onCloseRoomNotify()");
    var self = this;
    if (reason == 810) {
      wx.showModal({
        title: '关闭会议提示',
        content: '主持人已关闭会议。',
        showCancel: false
      });

      setTimeout(function() {
        self.leaveRoom();
      }, 2000);

    }
  },



  /**
   * @desc  用户回调事件
   * @param {Object} participants - 用户集数组
   */
  participantsHandle: function(participants) {
    console.log(new Date(), "+++participantsHandle+++,participants:", participants);
    var self = this;
    participants.forEach(function(user) {
        user.addCallback(app.data.getAvdSDK.Enum.UserCallback.board_share_result, self.onBoardShareResult);
		    user.addCallback(app.data.getAvdSDK.Enum.UserCallback.board_update_result, self.onBoardUpdateResult);
        user.addCallback(app.data.getAvdSDK.Enum.UserCallback.board_close_result, self.onBoardCloseResult);
        user.addCallback(app.data.getAvdSDK.Enum.UserCallback.board_remove_result, self.onBoardRemoveResult);
    });

    app.data.getAvdSDK.room.setUserCallbackMonitorState2True();
  },  



  onBoardShareResult: function(board){
      console.log(new Date(), "+++onBoardShareResult(),board:",board);
    
      //设置当前白板的渲染宽(高)度，输入的对应的x,y等坐标也是基于这个输入的宽(高)度重新计算的。
	    board.setRenderWidthAndHeight(this.data.currentBoardWidth,this.data.currentBoardHeight);
	    this.createBoardHandle(board);
  },


  onBoardUpdateResult: function(boardId,backgroundColor,backgroundImage){
    console.log(new Date(), "+++onBoardUpdateResult()");
  },

  onBoardCloseResult: function(boardId){
    console.log(new Date(), "+++onBoardCloseResult()");
    this.closeBoardHandle(boardId);
  },

  
  onBoardRemoveResult: function(boardId) {
    //console.log(new Date(), "+++onBoardRemoveResult()");
    this.removeBoardHandle(boardId);
  },


  createBoardHandle: function(board) {
    var self = this;
  
    self.setData({
        myCanvasWidth: board.width,
        myCanvasHeight:board.height,
        myCanvasBackground: "rgba(" + board.backgroundColor +")"
    });

    self.data.currentBoardUserId = board.userId;
    self.data.currentBoardId = board.id;
    board.createAnnotation().then(function(annotation) {
       annotation.init('myCanvas');
       annotation.hlightPointInit('../resources/pen-shape/laserPenMove.png', 20, 20);
       annotation.setArrowType(app.data.getAvdSDK.Enum.arrowTypeEnum.none);
       annotation.setShapeType(5);
       self.setData({
         currentShapeTypeIndex: 1
       });
       self.changBoard(board.userId, board.id);
    });
  },


  closeBoardHandle: function(boardId) {
    var self = this;
    self.setData({
        myCanvasWidth: 0,
        myCanvasHeight:0,
        myCanvasBackground:"rgba(0,0,0,0)"
    });

    self.data.currentBoardUserId = null;
    self.data.currentBoardId = null;
  },

  removeBoardHandle: function(boardId) {
    var self = this;

    self.setData({
        myCanvasWidth: 0,
        myCanvasHeight:0,
        myCanvasBackground:"rgba(0,0,0,0)"
    });

    self.data.currentBoardUserId = null;
    self.data.currentBoardId = null;
  },
  
  changBoard: function (boardUserId, boardId) {
      var boardUser = app.data.getAvdSDK.room.getUser(boardUserId);
      if(boardUser) {
        var board = boardUser.getBoard(boardId);
        this.data.currentBoardUserId = boardUserId;
        this.data.currentBoardId = boardId;
      }
  },


  onTouchStart: function(e){
    var self = this;

    self.isMouseDown = true;
    let x = e.touches[0].x
    let y = e.touches[0].y
    console.log(new Date(), "+++onTouchStart(),x:"+x+",y:"+y);

    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
        currentBoard.annotation.touchStart(x,y);
    }
  },


  onTouchMove: function(e){
    var self = this;
    if (self.isMouseDown){
        let x = e.touches[0].x
        let y = e.touches[0].y
        // console.log(new Date(), "+++onTouchMove(),x:"+x+",y:"+y);

        var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
        if(currentBoard) {
            currentBoard.annotation.touchMove(x,y);
        }
    }
  },
    

  onTouchEnd: function(e){
    var self = this;

    self.isMouseDown = false;

    let x = e.changedTouches[0].x
    let y = e.changedTouches[0].y
    console.log(new Date(), "+++touchEnd(),x:"+x+",y:"+y);

    var currentBoard = self.getCurrentBoard(self.data.currentBoardUserId,self.data.currentBoardId);
    if(currentBoard) {
        currentBoard.annotation.touchEnd(x,y);
    }
  },

  getCurrentBoard: function(userId,boardId){
     var currentBoard = null;
     var user = app.data.getAvdSDK.room.getUser(userId);
     if(user) {
         currentBoard = user.getBoard(boardId);
     }
     return currentBoard;
  },



  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var self = this;
    wx.createSelectorQuery().select('.home_content').boundingClientRect(function(rect){ 
      self.setData({
        currentBoardHeight: rect.height
      })
    }).exec()

    self.isMouseDown = false;

    self.participantsHandle(app.data.getAvdSDK.room.getParticipants());
    self.registerRoomCallback();

    self.setData({
      roomId: app.data.getAvdSDK.room.id
    });

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})