var api = require('../../restApi/api.js');

//获取应用实例
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
     inviteManager: null,
     serverAccount:'chengdu',
     tipsMessage:'',
     roomId:''
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var self = this;
   
    //app.watch(this.data, this.watch, this);

    this.registerClientCallback();
    this.data.inviteManager = app.data.avdSDK.client.getInviteManager();
  },


  // watch: {
  //   tipsMessage(val, old) {
  //     if (val !== '') {
  //        console.log('+++watching val:', val)
  //     }
  //   }
  // },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
      
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  },

  toCall:function(){
     var self = this;
     
     //TODO
    //  self.data.roomId = "18626880821";
    //  self.joinRoom();


     self.createRoom().then(function(roomId){
         console.log("+++roomId:", roomId);
         self.data.roomId = roomId;
         self.call();
     }).catch(function(error){
       self.setData({
          tipsMessage: '房间创建失败。error:' + error.msg
       })
     });
  },

  //创建房间
  createRoom:function(){
      var self = this;
      var promise = new Promise((resolve, reject) => {
          var topic = 'testingMeeting';
          var userId = app.data.avdSDK.client.selfUser.userId;
          api.createRoom(app.data.accessToken, topic, userId).then((res) => {
              console.log('+++restApi.createRoom() Success.res:', res)
              resolve(res.room_id);
          }).catch((error) => {
              console.log("+++createRoom(),error:",error);
              reject(error);
          })
      });
      return promise;
  },

  /**
  * 注册Client级别回调 
  */
  registerClientCallback: function(){
    app.data.avdSDK.client.addCallback(app.data.avdSDK.Enum.ClientCallbackEnum.NATIVE_PAYLOAD_NOTIFY, this.onNativePayload);
  },


  onNativePayload: function (topic, payload) {
      console.log("+++onNativePayload(),topic:" + topic + ",payload:", payload);
  },


  call: function(){
    var self = this;
    var options = {
       'roomId': self.data.roomId
    };

    var userId = app.data.avdSDK.client.selfUser.userId;
    var callInvite = self.data.inviteManager.createInvite(userId, self.data.serverAccount, options);
    
    self.registerInviteCallback(callInvite);

    self.data.inviteManager.call(callInvite).then(function () {
          console.log('+++邀请发送成功!');
          self.setData({
              tipsMessage: "邀请发送成功,等待对方接受..."
          });
    }).catch(function (error) {
          console.log('+++邀请发送失败！' + error.code + '/' + error.message);
          self.setData({
             tipsMessage: "邀请发送失败" + error.code + '/' + error.message
          });
    });
  },

  
 registerInviteManagerCallback:function(){
   var self = this;
   self.data.inviteManager.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_ACCEPT_NOTIFY, onCall);
  },

  onCall:function(){

  },


  /**
   * 注册Invite级别回调 
   */
  registerInviteCallback: function (invite){
    var self = this;

    invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_ACCEPT_NOTIFY, self.onCallAccept);
    invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_REJECT_NOTIFY, this.onCallReject);
    invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_TIMEOUT_NOTIFY, this.onCallTimeout);
    invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_RINGING_NOTIFY, this.onCallRinging);

    //  invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_CANCEL_NOTIFY, this.onCallCancel);
    // invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.RESPONSE_CALL_TIMEOUT_NOTIFY, this.onResponseCallTimeout);

   invite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_CLOSE_NOTIFY, this.onCallClose);
  
  },


  //邀请请求已被接受的回调
  onCallAccept: function (toUserId, options) {
      console.log("+++onCallAccept()++++++toUserId:" + toUserId + ";options:" + options);
      this.setData({
          tipsMessage: toUserId+"接受了您的邀请"
      });
      this.joinRoom();
  },

  //邀请请求已被拒绝的回调
  onCallReject: function(toUserId, reson){
    var self = this;
    console.log("+++onCallReject()++++++toUserId:" + toUserId + ";reson:" + reson);
    self.setData({
        tipsMessage: toUserId + "拒绝了邀请"
    })
  },


  //邀请请求无响应，超时回调
  onCallTimeout: function(toUserId){
    var self = this;
    console.log("+++onCallTimeout()++++++toUserId:" + toUserId);
    self.setData({
      tipsMessage: "发送邀请" + toUserId + "无响应，已超时"
    })
  },


  //邀请请求响铃回调
  onCallRinging: function (toUserId){
     console.log("+++onCallRinging()++++++toUserId:" + toUserId);
  },
   

  onCallClose: function(fromUserId, reson){
    console.log("+++onCallClose()++++++fromUserId:" + fromUserId + ";reson:" + reson);
  },


  joinRoom:function(){
      console.log(new Date(), "++++++join room start++++++===");

      wx.showLoading({
         title: '加会中...',
         mask: true
      });

    //  app.data.avdSDK.avdEngine.setVideoCoding(app.data.avdSDK.Enum.VideoCodingType.H264);
    //  app.data.avdSDK.avdEngine.setAudioCoding(app.data.avdSDK.Enum.AudioCodingType.opus);
     
     console.log("joinRoom(),serverUrl:", app.data.config.serverUrl);
     console.log("joinRoom(),accessToken:", app.data.accessToken);

    app.data.avdSDK.avdEngine.init(app.data.config.serverUrl, app.data.accessToken).then(this.initSuccess).catch(this.initError);
  },

  initSuccess: function () {
    console.log(new Date(), "++++++initSuccess++++++");
    app.data.avdSDK.room = app.data.avdSDK.avdEngine.obtainRoom(this.data.roomId);
    app.data.avdSDK.room.join(app.data.userInfo.userId, app.data.userInfo.userName, null, null).then(this.joinSuccess).catch(this.joinError);
  },
 
  initError: function (e) {
    console.log(e);
    wx.hideLoading();
    wx.showModal({
      title: '出错提示',
      content: "网络故障，服务器连接超时。可刷新重试! 错误码:" + e.error.code + ",错误信息：" + e.error.message,
      showCancel: false
    })
  },

  joinSuccess: function () {
    console.log(new Date(), "++++++joinSuccess++++++");
    var self = this;

    wx.hideLoading();
    var url = "../avd/avd";
    wx.reLaunch({
      url: url
    });
  },


  joinError: function (e) {
    wx.hideLoading();
    console.log(new Date(), "++++++joinError++++++", e.error);
    wx.showModal({
      title: '出错提示',
      content: "加会失败了! 错误码:" + e.error.code + ",错误信息：" + e.error.message,
      showCancel: false
    })
  },


  back2acdgroup: function () {
    var url = "../acdgroup/acdgroup"
    wx.reLaunch({
      url: url
    });
  }
})