
var api = require('../../restApi/api.js');
var config = require('../../config.js');

//获取应用实例
const app = getApp();

Page({

  /**
   * 页面的初始数据
   */
  data: {
    isUserAccountFocus: false,
    isPasswordFocus: false,
    userAccount: '',
    userPassword: '',
    errorMessage: ''
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var self = this;
    self.getAccessToken().then(function(token){
        console.log("+++accessToken:", token);
        app.data.accessToken = token;
        app.data.avdSDK.client.setParameters(app.data.config.serverUrl, token);
    }).catch(function(error){
        console.log(error);
        self.setData({
            errorMessage: '获取访问令牌失败。error:' + error.msg
        })
    });
  },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  getAccessToken:function(){
    var self = this;
    var promise = new Promise((resolve, reject) => {
       api.getAccessToken(config.accessKey, config.secretKey).then((data) => {
          resolve(data.token);
       }).catch((error) => {
         reject(error);
       });
    });
    return promise;
  },

  

  //绑定userAccount输入框
  setUserAccount: function (e) {
    var self = this;
    self.setData({
       userAccount: e.detail.value
    });
  },

  //绑定userPassword输入框
  setUserPassword: function (e) {
    var self = this;
    self.setData({
      userPassword: e.detail.value
    });
  },


  /**
   * 登陆
   */
  login: function () {
    var self = this;
    var userAccount = self.data.userAccount;
    if (!userAccount) {
      self.setData({
        errorMessage: "请输入用户帐号"
      })
      return;
    }
    var userPassword = self.data.userPassword;
    if (userPassword !=''){
       if(userPassword.length < 6 || userPassword.length > 16){
         self.setData({
           errorMessage: "请输入6 - 16位的登录密码"
         })
         return;
       }
    }
    
    wx.showLoading({
      title: '登陆中...',
      mask: true
    })


    var client = app.data.avdSDK.client;
    var keepalive = 15; //注册连接保活时长(秒为单位)) - 可以不填，默认60秒
    client.login(this.data.userAccount,this.data.userAccount, this.data.userPassword, keepalive).then(function () {
      wx.hideLoading();
      console.log('+++信令注册登录成功');

      app.data.userInfo.userId = userAccount;
      app.data.userInfo.userName = userAccount;
      
      wx.setStorageSync("userAccount", userAccount);
      var url = "../acdgroup/acdgroup"
      wx.reLaunch({
          url: url
      });
    }).catch(function (e) {
      wx.hideLoading();
      console.log('+++信令注册登录失败！', e.message);
      if (e.code == 2) {
        e.message = "帐号重复登录";
      }else if (e.code == 1502){
        e.message = "网络异常,连不上路由服务器，请检查网络"
      }
      self.setData({
        errorMessage:"登录失败,原因:" + e.message
      })
    });

  }

})