
module.exports = {

    /**
     * @desc 分页对应页面类型
     * @enum {number}
    */
    pageType: {
      userList: 0,  //用户列表页面
      chat:1    // 用户聊天页面
    },

    // /**
    //  * @desc 布局模式类型枚举
    //  * @enum {number}
    // */
    // patternType:{
    //   lecturer: 0,    //演讲者模式
    //   gallery: 1      //画廊模式
    // },

    /**
     * @desc 大屏模式类型枚举,数值越大，权重越大
     * @enum {number}
     */
    LargerScreenPatternType: {
      own: 0,             //自己，如会议里只有自己1人时，大屏显示自己的视频
      other: 1,           //对方，如会议里只有2人时，大屏显示对方的视频
      // spokesman: 2,       //当前发言人(语音激励)
      // locking: 3,         //选定视频
      // focus: 4,           //焦点视频
      // desktopSharing: 5,  //桌面共享
    },


    /**
     * @desc JHcallback枚举
     * @enum {String}
     * @ignore
     */
    JHCallback: {
       update_larger_screen_pattern: "update.larger.screen.pattern",
     
    },


    /**
     * @desc 房间级别的AppData中KEY枚举
     * @enum {String}
     */
    appDataMeeting: {
      host: "meeting_host",                 //用于设置主持人ID.默认值由客户端房间建创者加会时填入
      focusVideo: "meeting_focusVideo",     //设置焦点视频的用户ID
      muteAudioAll: "meeting_muteAudioAll",  //设置全员禁言或取消全员禁言
      forbiddenCameraAll: "meeting_forbiddenCameraAll",  //设置全员禁视频或取消全员禁视频
      lecturer: "meeting_lecturer",     //当前发言人 userId，主持人语音激励来获取，更新给所有与会者
      interact: "meeting_interact",     //用于设置当前影像诊断的操作人，同一时刻唯一
      controller: "meeting_layout_controller",    //用于设置当前场控
      lock: "meeting_lock"    //用于设置当前会议是否锁定
    }

};
