//本地工程环境运行时会走http协议，用dev.3tee.cn:81， nodejs环境运行时会走https协议，用dev.3tee.cn:441
// var serverURL = 'dev.3tee.cn:441';
// var serverURL = 'dev.3tee.cn:81';
// var accessKey = 'sdk2020_demo_access';
// var secretKey = 'sdk2020_demo_secret';


var serverURL = 'avd.nice2meet.cn:9609';
var accessKey = 'demo_access';
var secretKey = 'demo_secret';


var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 9000) + 1000);

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();

avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice().then(checkResult);
// avdEngine.setVideoCoding(VideoCodingType.H264);
var restApi = new RestApi(serverURL);

var isRoomOwer = false;
var self = this;

var localVideo = document.getElementById("localVideo");
var remoteAudio = document.getElementById("remoteAudio");
var remoteVideo = document.getElementById("remoteVideo");
var local_video = document.getElementById("local_video");
var local_audio = document.getElementById("local_audio");
var remote_video = document.getElementById("remote_video");
var remote_audio = document.getElementById("remote_audio");
var frontCam = document.getElementById('frontCam');
var backCam = document.getElementById('backCam');
var localVideoId = '';
var localAudioId = '';
var isOpenVideoShow = true;
var isOpenAudioShow = true;

var isVideoFacility = false
var isAudioFacility = false

var isFirstSafariAudio = false
var firstSafariAudioStream;
restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('Success', res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error", error);
    $(".promptMsg").html('getAccessToken(),error:' + error.msg);

})

function checkResult() {
    isVideoFacility = avdEngine.hasCamera;
    isAudioFacility = avdEngine.hasMicrophone;
}

function checkError(error) {
    $(".promptMsg").html("get device error!error code:" + error.code + "; error message:" + error.message);
}

function createRoom() {
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        console.log('Success', res)
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        console.log("Error", error)
        $(".promptMsg").html('createRoom(),error:' + error.msg);
    })
}

function joinRoom() {
    if (room) { return }
    if (!isVideoFacility) {
        $('.promptMsg').html('没有摄像头设备，请插入');
    } else if (!isAudioFacility) {
        $('.promptMsg').html('没有音频设备，请插入');
    } else if ($("#first").val() == '') {
        $('.promptMsg').html('会议号不能为空，请先创建房间');
    } else {
        self.roomId = $("#first").val();
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

function initSuccess() {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

function initError(error) {
    $(".promptMsg").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}

function joinSuccess() {
    console.log('加入会议成功');

    openCamera();
    openMicrophone();

    registerRoomCallback();

    //加会登陆前，会议中已经发布的视频资源,采取订阅处理
    onPublishCameraNotify(room.pubVideos);

    participantsHandle(room.getParticipants());

    $('.localVideo_userName').html(self.userName + "(我)");
}

function joinError(error) {
    console.log('==================joinError(),error:', error)
    if (error.code == 404) {
        $(".promptMsg").html("加会失败！原因房间没有找到，请核实。joinError(),error");
    } else {
        $(".promptMsg").html('joinError(),error:' + error.message + "[" + error.code + "]");
    }
}

function openCamera() {
    console.log('opencamera: ', isOpenVideoShow);
    if (isOpenVideoShow) {
        isOpenVideoShow = false;
        videos = room.selfUser.videos;
        if (videos && videos.length > 0) {
            var video = videos[0];
            video.updateCameraData(1, JSON.stringify({"video_name":"front"}));
            // 如果手机端访问，则不止一个摄像头，添加后置功能
            room.selfUser.openMobileFrontVideo(localVideo);
        }
    }
}

function closeCamera() {
    console.log('closecamera: ', isOpenVideoShow);
    if (!isOpenVideoShow) {
        isOpenVideoShow = true;
        var video = room.selfUser.videos[0];
        if (video && videos.length > 0) {
            local_video.className = 'closeCamera';
            video.unpreview();
            video.unpublish();
        }
    }
}

function openMicrophone() {
    console.log(`+++123openMicrophone`);
    if (isOpenAudioShow) {
        isOpenAudioShow = false;
        var audio = room.selfUser.audio;
        localAudioId = audio.id;
        if (audio) {
            audio.openMicrophone().otherwise(showError);
            local_audio.className = 'openMicrophone';
        }
    }
}



function muteMicrophone() {
    if (!isOpenAudioShow) {
        isOpenAudioShow = true;
        var audio = room.selfUser.getAudio(self.localAudioId);
        if (audio) {
            local_audio.className = 'closeMicrophone';
            audio.muteMicrophone();
        }
    }
}

function unmuteMicrophone(){
    if(isOpenAudioShow){
        isOpenAudioShow = false;
        var audio = room.selfUser.audio;
        if(audio && audio.status == StreamStatus.muted){
            audio.unmuteMicrophone();
            local_audio.className = 'openMicrophone';
        }
    }
}

function showError(error) {
    $(".promptMsg").html('showError(),error:' + error.message + "[" + error.code + "]");
}

//退会
function leaveRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
        var reason = 1; //退会原因
        room.leave(reason).then(function () {
            top.location = "index.html";
            return false;
        });
    }
}

function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
	room.addCallback(RoomCallback.leave_indication, onLeaveIndication);
	
	room.addCallback(RoomCallback.close_room_result, onCloseRoomResult);
	room.addCallback(RoomCallback.close_room_notify, onCloseRoomNotify);

    room.addCallback(RoomCallback.user_data_notify, onUserDataNotify);
}

function onUserDataNotify(userData, userId){

}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".promptMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".promptMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".promptMsg").html("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    console.log("============onUserJoinNotify(),users:", users);
    participantsHandle(users);
}

/**
 * @desc 参会者退会回调
 * @param {int} opt - 退会类型
 * @param {int} reason  - 退会原因
 * @param {Object} user - 退会用户
 */
function onUserLeaveNotify(opt, reason, user) {
	
	//udp媒体通道建立超时807错误
	if(reason == 807) {
	    console.log("807错误,UDP不通或udp媒体通道建立超时!");
	}
	
	if(reason == 812){//用户心跳超时掉线（如异常退会）
		 console.log(user.id+" 已异常退会");
	}else{
		 console.log(user.id+" 已退会");
	}
	
	isFirstSafariAudio = false;
	
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
    $('.remoteVideo_userName').html('');
    remote_video.className = '';
    remote_audio.className = '';
}


/**
 * @desc 被踢出会议室
 * @param {Object} reason - 被踢原因
 * @param {Object} userId - 踢人的操作者
 */
function onLeaveIndication(reason, userId) {
	console.log("+++onLeaveIndication(),reason:" + reason + ",userId:" + userId);
	if(reason == 804) {
		//同一个userid加会， 把前一个人踢下线
		console.log("你已在另一个地方登陆，被踢出会议室。被踢原因：" + reason);
	} else if(reason == 808) {
		//调用Restful接口把人踢下线或SDK调踢人接口通知会议中的第三方用户
		console.log("你被" + userId + "踢出会议室。被踢原因：" + reason);
	} else {
		console.log("你被" + userId + "踢出会议室。被踢原因：" + reason);
	}
	
	top.location = "index.html";
	return false;
}


/**
 * @desc 关闭会议回调结果
 * @param {int} result - 关闭结果
 * @param {String} description - 描述
 */
function onCloseRoomResult(result, description) {
	console.log("+++onCloseRoomResult(),result:"+result+",description:"+description);
	if(result == 0) {
		console.log("关闭会议成功");
		top.location = "index.html";
		return false;
    }
}


/**
 * @desc 收到关闭房间通知，退出会议操作
 * @param {int} roomId - 房间ID
 * @param {int} reason  -关闭会议原因
 */
function onCloseRoomNotify(roomId, reason) {
	console.log("+++onCloseRoomNotify(),roomId:"+roomId+",reason:"+reason);
	
	var tips = "";
	if(reason == 809) {
		tips = "服务没有授权用户入会(最多2个用户),超过15分钟服务器主动关闭房间强制踢人";
	}else if(reason == 810) {
		tips = "SDK调用接口关闭会议";
	}else if(reason == 811){
		tips = "服务更新维护时关闭会议";
	}else if(reason == 815){
		tips = "调用restful接口关闭会议";
	}	
	
	console.log("会议已关闭。原因:" + tips);
	
	top.location = "index.html";
	return false;
}	



/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {
    participants.forEach(function (user) {
        user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
        user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);

        user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
        user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
        user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
        user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);

        user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
        user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);
    })
}

/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
    if (userId == room.selfUser.id) {
        console.log('+++onMicrophoneStatusNotify, selfUser,  status: ',status );
        if (status == StreamStatus.published) {
            local_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            local_audio.className = 'closeMicrophone';
        } else if (status == StreamStatus.muted){
            local_audio.className = 'closeMicrophone';
        }
    } else {
        console.log('+++onMicrophoneStatusNotify, remoteUser,  status: ',status );
        if (status == StreamStatus.published) {
            remote_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            remote_audio.className = 'closeMicrophone';
        } else if (status == StreamStatus.muted){
            remote_audio.className = 'closeMicrophone';
        }
    }
}

/**
 * 房间中发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
    video.unsubscrible();
}

/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            local_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            local_video.className = 'closeCamera';
        }
    } else {
        if (status == StreamStatus.published) {
            remote_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            remote_video.className = 'closeCamera';
        }
    }
}

//订阅未订阅的视频
function onPublishCameraNotify(videos) {
    videos.forEach(function (video) {
        //只订阅未订阅过的视频
        var subVideoIdsLen = room.selfUser.subVideoIds.length;
        if (subVideoIdsLen > 0) {
            var isSub = false;
            for (var i = 0; i < subVideoIdsLen; i++) {
                var videoId = room.selfUser.subVideoIds[i];
                if (video.id == videoId) {
                    isSub = true;
                    break;
                }
            }
            if (!isSub) {
                video.subscrible();
            }
        } else {
            video.subscrible();
        }
    });
}

/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
    $('.remoteVideo_userName').html(userName + "(远端)");
    remote_video.className = 'openCamera';
    room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
    log.info(`+++123, onSubscribleMicrophoneResult, ${userName}'s microphone stream ${stream}`);
    remote_audio.className = 'openMicrophone';
    var remoteAudio = document.getElementById('remoteAudio');
    if(room.avdEngine.isSafari){
        if(isFirstSafariAudio && remoteAudio){
            room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
        }
        else{
            isFirstSafariAudio = true;
            firstSafariAudioStream = stream;
            $('.safariAudioNotice').show();
        }
    }
    else{
        room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
    }
}

function safariAudioHandle(){
    $('.safariAudioNotice').hide();
    var remoteAudio = document.getElementById('remoteAudio');
    if(remoteAudio){
        room.selfUser.attachAudioElementMediaStream(remoteAudio, firstSafariAudioStream);
    }
}

/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
	isFirstSafariAudio = false;
    room.selfUser.attachAudioElementMediaStream(remoteAudio, null);
}

function turnFront(){
    room.selfUser.closeMobileBackVideo(localVideo);
    room.selfUser.openMobileFrontVideo(localVideo);
    backCam.disabled = false;
    frontCam.disabled = true;
}

function turnBack(){
    room.selfUser.closeMobileFrontVideo(localVideo);
    room.selfUser.openMobileBackVideo(localVideo);
    backCam.disabled = true;
    frontCam.disabled = false;
}