var serverURL = 'box.nice2meet.cn';

var accessKey = 'demo_access';
var secretKey = 'demo_secret';
var accessToken = null;

var roomId = parseInt(Math.floor(Math.random() * 90000000000) + 10000000000);
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 90000) + 10000);

var self = this;

var protocolStr = document.location.protocol;
var httpHost = window.location.host;
var hostname = window.location.hostname;
if (httpHost && hostname != "localhost" && hostname != "127.0.0.1" && httpHost != "192.168.1.13:8081") {
    serverURL = httpHost;
}

var restApi = new RestApi(serverURL);
console.log("==================protocolStr:", protocolStr);
console.log("==================httpHost:", httpHost);
console.log("==================hostname:", hostname);


var loginDiv = document.querySelector('.loginDiv');
var joinMeeting = document.getElementById('joinMeeting');
var account = document.getElementById('account');
var password = document.getElementById('password');
var errorMsg = document.getElementById('errorMsg');
var week = document.getElementById('week');

var errorTips = document.querySelector('.errorTips');
var meetingArrange = document.querySelector('.meetingArrange');
var invitList = document.querySelector('.invitList');
var allMeetingList = document.querySelector('.allMeetingList');

week.innerHTML = getWeekDate();

var userMsg;
var invitUserList = [];

restApi.getToken(accessKey, secretKey).then((res) => {
    console.log('======getToken  successs', res.token)
    accessToken = res.token;
}).otherwise((error) => {
    console.log('======getToken  error', error)
    // show(2);
    // errorMsg.innerHTML = '密码不能为空'
})





function login() {
    if (account.value == '') {
        show(2);
        errorMsg.innerHTML = '账号不能为空'
        return
    }

    if (password.value == '') {
        show(2);
        errorMsg.innerHTML = '密码不能为空'
        return
    }

    var userAccount = account.value;
    var userPassword = password.value;
    userPassword = md5(userPassword);
    restApi.login(userAccount, userPassword).then((res) => {
        console.log('直接登录成功', res)
        loginDiv.style.display = 'none';
        userMsg = res;
        
        getRoomList(userMsg.user_id, userMsg.session_id);
    }).otherwise((error) => {
        if (error.ret != '10101') {
            show(2);
            errorMsg.innerHTML = error.msg + '[' + error.ret + ']'
            console.log('直接登录失败', error.msg + '[' + error.ret + ']')
        } else {
            restApi.createUser(accessToken, userAccount, userAccount, password.value, roomId, 0).then((res) => {
                restApi.login(userAccount, userPassword).then((res) => {
                    console.log('创建后直接登录成功', res)
                    loginDiv.style.display = 'none';
                    userMsg = res;
                    getRoomList(userMsg.user_id, userMsg.session_id);
                }).otherwise((error) => {
                    show(2);
                    errorMsg.innerHTML = error.msg + '[' + error.ret + ']'
                    console.log('创建后登录失败', error.msg + '[' + error.ret + ']')
                })
            }).otherwise((error) => {
                show(2);
                errorMsg.innerHTML = error.msg + '[' + error.ret + ']'
                console.log('创建用户失败', error.msg + '[' + error.ret + ']')
            })
        }
    })
}

function getRoomList(userId, sessionId) {
    restApi.getRoomList(userId, sessionId).then((res) => {
        for (var i = 0; i < res.data.length; i++) {
            console.log('===========getRoomList success', res.data[i])
            var newDivAll = document.createElement("Div");
            var newDivTitle = document.createElement("Div");
            var newDivContent = document.createElement("Div");
            var newDivBottom = document.createElement("Div");
            var newSpanTitle1 = document.createElement("span");
            var newSpanTitle2 = document.createElement("span");
            var newSpanTitle3 = document.createElement("span");
            var newPContent1 = document.createElement("p");
            var newPContent2 = document.createElement("p");
            var newA1 = document.createElement("a");
            var newA2 = document.createElement("a");

            newSpanTitle1.innerHTML = getAmAndPmTime(res.data[i].start_time * 1000);
            newSpanTitle2.innerHTML = getAmAndPmTime(res.data[i].end_time * 1000);
            newSpanTitle3.className = 'itemSpan'
            newDivTitle.appendChild(newSpanTitle1);
            newDivTitle.appendChild(newSpanTitle3);
            newDivTitle.appendChild(newSpanTitle2);
            newDivTitle.className = 'itemTitle'

            newPContent1.innerHTML = '主题:' + res.data[i].topic;
            newPContent2.innerHTML = '会议号:' + res.data[i].room_id;
            newPContent1.className = 'itemP1'
            
            newDivContent.appendChild(newPContent1);
            newDivContent.appendChild(newPContent2);
            newDivContent.className = 'itemDiv';


            newA1.href = 'jh://j?id=' + res.data[i].room_id + "&serverUrl=" + protocolStr + '//' + serverURL;
            newA1.innerHTML = '开始';
            newA2.href = 'jh://j?id=' + res.data[i].room_id + "&serverUrl=" + protocolStr + '//' + serverURL;
            newA2.innerHTML = '加入';

            if (userMsg.user_id == res.data[i].owner_id) {
                newDivBottom.appendChild(newA1);
            } else {
                newDivBottom.appendChild(newA1);
            }
            newDivBottom.className = 'itemBottom';

            newDivAll.appendChild(newDivTitle);
            newDivAll.appendChild(newDivContent);
            newDivAll.appendChild(newDivBottom);
            newDivAll.className = 'allDiv'

            allMeetingList.appendChild(newDivAll);
        }
    }).otherwise((error) => {
        console.log('===========getRoomList error', error)
    })
}

function formatterTime(time, fmt) {
    if (!time) {
        return '';
    }

    if (typeof (time) == "object" || typeof (time) == "OBJECT") {
        var z = {
            M: time.getMonth() + 1,
            d: time.getDate(),
            h: time.getHours(),
            m: time.getMinutes(),
            s: time.getSeconds()
        };
        fmt = fmt.replace(/(M+|d+|h+|m+|s+)/g, function (v) {
            return ((v.length > 1 ? "0" : "") + eval('z.' + v.slice(-1))).slice(-2);
        });
        return fmt.replace(/(y+)/g, function (v) {
            return time.getFullYear().toString().slice(-v.length);
        });
    } else if (typeof (time) == "number") {
        var TIME = new Date(time);
        var z = {
            M: TIME.getMonth() + 1,
            d: TIME.getDate(),
            h: TIME.getHours(),
            m: TIME.getMinutes(),
            s: TIME.getSeconds()
        };
        fmt = fmt.replace(/(M+|d+|h+|m+|s+)/g, function (v) {
            return ((v.length > 1 ? "0" : "") + eval('z.' + v.slice(-1))).slice(-2);
        });
        return fmt.replace(/(y+)/g, function (v) {
            return TIME.getFullYear().toString().slice(-v.length);
        });
    }
    else return time;
}

function getWeekDate() {
    var now = new Date();
    var day = now.getDay();
    var weeks = new Array("星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六");
    var week = weeks[day];
    return week;
}

function getDayTime(time) {
    var timeStr;
    var curDate = new Date();
    var myDate = new Date(time);
    if (curDate.getFullYear() == myDate.getFullYear() && curDate.getMonth() == myDate.getMonth()) {
        if (curDate.getDate() == myDate.getDate()) {
            timeStr = '今天'
        } else {
            timeStr = getStanderTime(time);
        }
    } else {
        timeStr = getStanderTime(time);
    }
    return timeStr;
}


function getStanderTime(time) {
    var timeStr;
    var weekList = ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'];
    var myDate = new Date(time);
    var year = myDate.getFullYear();
    var month = myDate.getMonth() + 1;
    var day = myDate.getDate();
    var week = weekList[myDate.getDay()];
    timeStr = year + '.' + month + '.' + day + '   ' + week;
    return timeStr;
}

function getAmAndPmTime(time) {
    var timeStr;
    var myDate = new Date(time);
    var hours = myDate.getHours(); //获取当前小时数(0-23)
    var minutes = myDate.getMinutes(); //获取当前分钟数(0-59)

    if (hours < 10) {
        hours = '0' + hours;
    }
    if (minutes < 10) {
        minutes = '0' + minutes;
    }
    timeStr = hours + ':' + minutes
    return timeStr;
}

function completeInvitUserList() {
    var checkboxIpts = document.querySelectorAll('.checkboxIpt');
    for (var i = 0; i < checkboxIpts.length; i++) {
        if (checkboxIpts[i].checked) {
            invitUserList.push(checkboxIpts[i].value);
            show(7);
        }
    }
}

function updateMettingList() {
    if ($('#startTime').val() == '') {
        show(2);
        errorMsg.innerHTML = '开始时间是必须的';
        return
    }

    if ($('#endTime').val() == '') {
        show(2);
        errorMsg.innerHTML = '结束时间是必须的';
        return
    }

    if ($('#theme').val() == '') {
        show(2);
        errorMsg.innerHTML = '主题是必须的';
        return
    }
    var startTimeValue = $('#startTime').val();
    var endTimeValue = $('#endTime').val();
    var dot = /./;
    if (dot.test(startTimeValue)) {
        var startTimeArray = startTimeValue.split('.');
        var startTime = formatConversion( startTimeArray[0] );
    } else {
        var startTime = formatConversion( startTimeValue );
    }

    if (dot.test(endTimeValue)) {
        var endTimeArray = endTimeValue.split('.');
        var endTime = formatConversion( endTimeArray[0] );
    } else {
        var endTime = formatConversion( endTimeValue );
    }

    restApi.updateMettingList($('#roomId').val(), userMsg.session_id, startTime, endTime, $('#userId').val(), $('#theme').val(), $('#describe').val(), $('#maxJoinNum').val(), [], 0).then((res) => {
        console.log('updateMettingList success', res)
        show(5);
        allMeetingList.innerHTML = '';
        getRoomList(userMsg.user_id, userMsg.session_id);
    }).otherwise((error) => {
        console.log('updateMettingList error', error)
    })

}

function launchMeeting() {
    console.log('eeeeeeeeeeeelaunchMeeting', userMsg);
    alert('jh://j?id=' + userMsg.room_id + "&serverUrl=" + protocolStr + '//' + serverURL);
    window.location.href = 'jh://j?id=' + userMsg.room_id + "&serverUrl=" + protocolStr + '//' + serverURL + "&userName=h5";
    console.log('launchMeeting()  url', 'jh://j?id=' + userMsg.room_id + "&serverUrl=" + protocolStr + '//' + serverURL+ "&userName=h5");
    
}

function joinRoom() {
    var joinRoomId = document.getElementById('joinRoomId');
    window.location.href = 'jh://j?id=' + joinRoomId.value + "&serverUrl=" + protocolStr + '//' + serverURL + "&userName=h5";
    joinMeeting.style.display = 'none';
    joinRoomId.value = '';

    console.log('joinRoom()  url', 'jh://j?id=' + joinRoomId.value + "&serverUrl=" + protocolStr + '//' + serverURL + "&userName=h5");
}

function show(int) {
    if (int == 1) {
        joinMeeting.style.display = 'block';
    } else if (int == 0) {
        joinMeeting.style.display = 'none';
    } else if (int == 2) {
        errorTips.style.display = 'block';
    } else if (int == 3) {
        errorTips.style.display = 'none';
    } else if (int == 4) {
        $('#roomId').val(parseInt(Math.floor(Math.random() * 9000000000) + 1000000000));
        $('#userId').val(userMsg.user_id);
        meetingArrange.style.display = 'block';
    } else if (int == 5) {
        meetingArrange.style.display = 'none';
    } else if (int == 6) {
        invitList.style.display = 'block';
    } else if (int == 7) {
        invitList.style.display = 'none';
    }
}

function logout() {
    location.reload();
}

function formatConversion( value ) {
    var starttime = value.replace(new RegExp("T")," ");
    var ccc = starttime.replace(new RegExp("-","gm"),"/");
    var ddd = (new Date(ccc)).getTime()/1000
    return ddd
}