
// var serverURL = 'dev.3tee.cn:441';
// var serverURL = 'dev.3tee.cn:81';
// var accessKey = 'sdk2020_demo_access';
// var secretKey = 'sdk2020_demo_secret';


// var serverURL = 'avd.nice2meet.cn:9509';
// var serverURL = 'box.nice2meet.cn';


var testpayload = null;
var serverURL = 'avd.nice2meet.cn:9609';
var accessKey = 'demo_access';
var secretKey = 'demo_secret';

var accessToken = null;

var roomId = null;
var userId = null;
var userName = null;

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();
avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.setVideoCoding(VideoCodingType.H264);
avdEngine.initDevice();


var client, inviteManager, rpcManager, acceptInvite, callInvite, invite;
var num = 0;
var self = this;


var localVideo = document.getElementById("localVideo");
var remoteAudio = document.getElementById("remoteAudio");
var remoteVideo = document.getElementById("remoteVideo");


var protocolStr = document.location.protocol;
var httpHost = window.location.host;
var hostname = window.location.hostname;
if (httpHost && hostname != "localhost" && hostname != "127.0.0.1" && httpHost != "192.168.1.13:8081") {
    serverURL = httpHost;
}
var restApi = new RestApi(serverURL);
console.log("==================serverURL:", serverURL);


restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('=====restApi.getAccessToken() success. res:', res)
    accessToken = res.token;
}).catch((error) => {
    console.log("Error", error);
    $(".loginMsg").html('getAccessToken(),error:' + error.msg);
})


function createRoom() {
    var promise = new Promise((resolve, reject) => {
        var topic = 'testingMeeting';
        restApi.createRoom(accessToken, topic, userId).then((res) => {
            console.log('restApi.createRoom() Success.res:', res)
            roomId = res.room_id;
            resolve();
        }).catch((error) => {
            console.log("Error", error);
            reject(error);
        })
    });
    return promise;
}

function login() {
    var self = this;
    var account = $('#account').val();
    var password = $('#passwrod').val();
    if (account == '') {
        $(".loginMsg").html('用户帐号不能为空');
        return
    }
    var Client = ModuleBase.use(ModulesEnum.client);
    client = new Client(serverURL, accessToken);

    client.login(account, password).then(function () {
        console.log('信令注册登录成功');
        $(".loginMsg").html('登录成功,用户帐号:' + account);
        
		registerClientCallback();

        inviteManager = client.getInviteManager();
        rpcManager = client.getRpcManager();
        
        registerInviteManagerCallback();
		
        userId = account;
        userName = account;
        
        self.getMqttUserList();

        // var topic = "layout_sync";
		// client.nativeSubscribe(topic).then(function(){
		// 	console.log('原生消息订阅成功,topic:'+subscribeTopic);
		// }).otherwise(function(error){
		// 	console.error('原生消息订阅失败。topic:'+subscribeTopic+',error:'+error.message+"["+error.code+"]");
        // });
        
        var subscribeTopic = "user_online_status";
        client.nativeSubscribe(subscribeTopic).then(function(){
            console.debug("原生消息订阅成功");     
        }).otherwise(function(error){
            console.error('原生消息订阅失败。error:'+error.message+"["+error.code+"]");
        });  
		
    }).otherwise(function (error) {
        console.log('信令注册登录失败！' + error.message + "[" + error.code + ']');
        $(".loginMsg").html('信令注册登录失败！' + error.message + "[" + error.code + ']');
    });
}



function setClientOptions(clientId, userAgent, userName) {
		var self = this;
		var jsonObj = {
			"id": userName,
			"jsonrpc": "2.0",
			"method": "setClientOptions",
			"params": {
				"clientId": clientId,
				"userAgent": userAgent,
				"userName": userName,
			}
		};

		rpcManager.notification(jsonObj).then(function() {
			console.log("上报用户成功");
		}).otherwise(function(error){
			console.log('上报用户失败',error);
        });
        
}


/**
 * 注册Client级别回调 
 */
function registerClientCallback(){
	  client.addCallback(client.ClientCallbackEnum.NATIVE_PAYLOAD_NOTIFY, onNativePayload);
}

/**
 * 注册InviteManager级别回调 
 */
function registerInviteManagerCallback() {
    inviteManager.addCallback(inviteManager.InviteManagerCallbackEnum.CALL_NOTIFY, onCall);
}

/**
 * 注册Invite级别回调 
 */
function registerInviteCallback(invite) {
    // 添加呼叫同意回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_ACCEPT_NOTIFY, onCallAccept);
    // 添加呼叫被拒绝回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_REJECT_NOTIFY, onCallReject);
    // 添加呼叫超时回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_TIMEOUT_NOTIFY, onCallTimeout);
    // 添加呼叫振铃回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_RINGING_NOTIFY, onCallRinging);
    // 添加呼叫取消回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_CANCEL_NOTIFY, onCallCancel);
    // 添加响应超时回调
    invite.addCallback(invite.InviteCallbackEnum.RESPONSE_CALL_TIMEOUT_NOTIFY, onResponseCallTimeout);
    // 添加呼叫关闭回调回调
    invite.addCallback(invite.InviteCallbackEnum.CALL_CLOSE_NOTIFY, onCallClose);
}

function onNativePayload(topic,payload){
    testpayload = payload;
    console.log("+++onNativePayload(),topic: " + topic + ",payload: ", payload); 
}

function getMqttUserList(){
    var self = this;
    var jsonObj = {
        "jsonrpc": "2.0", 
        "id": "300", 
        "method": "getUserList",
        "params": {}
    }
    self.rpcManager.call(jsonObj).then((res)=>{
        console.info("+++getMqttUserList(), MqttUsers:", res.data);      
    }).otherwise((error)=>{
        console.error("+++getMqttUserList(): error", error);      
    })
}

function call() {
    if (!client) {
        $('.loginMsg').html('请先登录');
        return
    }
    var onCallId = $('#onCallId').val();
    if (onCallId == '') {
        $('.inviteMsg').html('对方用户帐号不能为空!');
        return
    }

    createRoom().then(() => {
        var options = {
            'roomId': roomId,
        }

        callInvite = self.inviteManager.createInvite($('#account').val(), onCallId, options);
        registerInviteCallback(callInvite);

        inviteManager.call(callInvite).then(() => {
            console.log('邀请发送成功!');
            $('.inviteMsg').html('邀请发送成功,等待对方接受...');
        }).otherwise((error) => {
            log.error('邀请发送失败！' + error.code + '/' + error.message);
            $('.inviteMsg').html('邀请发送失败！' + error.code + '/' + error.message);
        })
    }).catch((error) => {
        $(".inviteMsg").html('createRoom(),error:' + error.msg);
    });
}

function onCall(invite) {
    acceptInvite = invite;
    registerInviteCallback(invite);
    self.invite = invite;
	
	$('.inviteMessage').html('');

    invite.ringing().then(function () {
        console.log("发送振铃成功");
        $('.onCallIsShow').css({
            'display': 'block'
        });

        roomId = invite.options.roomId;
        $('.onCallMsg').html(invite.toUserId + '向您发送邀请,请选择接受或者拒绝该请求。');

    }).otherwise(function (error) {
        log.error("发送振铃失败。error：", error);
        $('.inviteMsg').html("发送振铃失败。error：", error)
    })
}

// 邀请请求已被接受的回调
function onCallAccept(toUserId, options) {
    console.log("======onCallAccept()=====toUserId:" + toUserId + ";options:" + options);
    $('.inviteMsg').html('对方接受邀请成功');

    console.log("============发启端加会会议，roomId:", roomId);
    joinRoom();
}


// 邀请请求已被拒绝的回调
function onCallReject(toUserId, reson) {
    console.log("======onCallReject()=====toUserId:" + toUserId + ";reson:" + reson);
    $('.inviteMsg').html('对方拒绝了邀请');
}

//邀请请求无响应，超时回调
function onCallTimeout(toUserId) {
    console.log("======onCallTimeout()=====toUserId:" + toUserId);
    $('.inviteMsg').html('发送邀请对方无响应，已超时');
}

//邀请请求响铃回调
function onCallRinging(toUserId) {
    console.log("======onCallRinging()=====toUserId:" + toUserId);
}


//邀请发启者取消邀请的回调
function onCallCancel(fromUserId) {
    console.log("======onCallCancel()=====fromUserId:" + fromUserId);
	$('.onCallIsShow').css({
	    'display': 'none'
	})
	$('.inviteMessage').html('对方取消了邀请');
}

//接收邀请者无响应，超时回调
function onResponseCallTimeout(fromUserId) {
    console.log("======onResponseCallTimeout()=====fromUserId:" + fromUserId);
    $('.onCallIsShow').css({
        'display': 'none'
    })
    $('.inviteMessage').html('收到邀请，未作出响应，已超时');
}

function onCallClose(fromUserId, reson) {
    console.log("======onCallClose()=====fromUserId:" + fromUserId + ";reson:" + reson);
    leaveRoom();
}

function accept() {
    $('.onCallIsShow').css({
        'display': 'none'
    })

    self.invite.accept().then(() => {
        console.log('接受邀请成功。');
        $('.inviteMessage').html('接受邀请成功。');

        console.log("=============接受端加入会议：roomId:", roomId);
        joinRoom();
    }).otherwise(function (error) {
        log.error('接受邀请失败。error：', error);
        $('.inviteMessage').html('接受邀请失败。error：', error);
    })
}

function refuse() {
    $('.onCallIsShow').css({
        'display': 'none'
    })

    var reson = 'No reason'
    self.invite.reject(reson).then(function () {
        console.log('拒绝邀请成功。');
        $('.inviteMessage').html('拒绝邀请成功。');
    }).otherwise(function (error) {
        log.error('拒绝邀请失败。error：', error);
        $('.inviteMessage').html('拒绝邀请失败。error：', error);
    })
}

function joinRoom() {
    if (!roomId) {
        return
    }
    avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
}

function initSuccess() {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

function initError(error) {
    $(".inviteMessage").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}


function joinSuccess() {
    console.log('加入会议成功');

    openCamera();
    openMicrophone();

    registerRoomCallback();

    //加会登陆前，会议中已经发布的视频资源,采取订阅处理
    onPublishCameraNotify(room.pubVideos);

    participantsHandle(room.getParticipants());
}

function joinError(error) {
    if (error.code == 404) {
        $(".inviteMessage").html("加会失败！原因房间没有找到，请核实。joinError(),error");
    } else {
        $(".inviteMessage").html('joinError(),error:' + error.message + "[" + error.code + "]");
    }
}


function openCamera() {
    var videos = room.selfUser.videos;
    var videosNum = videos.length;

    for (var i = 0; i < videosNum; i++) {
        var video = videos[i];
        $('.videoDom').append('<div class="local" id="' + videos[i].id + '"><video id="localVideo' + i + '" autoplay muted></video></div>');

        var singleLocalVideo = document.getElementById('localVideo' + i);

        video.previewAndPublish(singleLocalVideo).otherwise(showError);
    }
}


function openMicrophone() {
    var audio = room.selfUser.audio;
    if (audio) {
        audio.openMicrophone().otherwise(showError);
    }
}

function showError(error) {
    $(".inviteMessage").html('showError(),error:' + error.message + "[" + error.code + "]");
}

function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".loginMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".loginMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".loginMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".loginMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".loginMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".loginMsg").html("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}


/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    console.log("============onUserJoinNotify(),users:", users);
    participantsHandle(users);
}


/**
 * @desc 参会者退会回调
 * @param {int} opt - 退会类型
 * @param {int} reason  - 退会原因
 * @param {Object} user - 退会用户
 */
function onUserLeaveNotify(opt, reason, user) {
    console.log("===========onUserLeaveNotify(),user:", user);

    //服务器端报807错误，说明UDP不通或UDP连接超时
    if (reason == 807) {
        $(".inviteMessage").html("807错误，UDP不通或UDP连接超时！");
        return;
    }
}


/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {
    participants.forEach(function (user) {
        user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
        user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);

        user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
        user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
        user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
        user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);

        user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
        user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);
    })
}

/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
    console.log("===============onCameraStatusNotify(),cameraId:", cameraId, "status:", status);
}


/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
    console.log("===============onMicrophoneStatusNotify(),microphoneId:", microphoneId, "status:", status);
}



//订阅未订阅的视频
function onPublishCameraNotify(videos) {
    console.log("=======================onPublishCameraNotify(),videos:", videos);
    videos.forEach(function (video) {
        //只订阅未订阅过的视频
        var subVideoIdsLen = room.selfUser.subVideoIds.length;
        if (subVideoIdsLen > 0) {
            var isSub = false;
            for (var i = 0; i < subVideoIdsLen; i++) {
                var videoId = room.selfUser.subVideoIds[i];
                if (video.id == videoId) {
                    isSub = true;
                    break;
                }
            }
            if (!isSub) {
                video.subscrible();
            }
        } else {
            video.subscrible();
        }
    });
}


/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
    num++;
    console.log("=======================onSubscribleCameraResult(),userId:", userId);
    $('.remoteVideoDom').append('<div class="local" id="' + userId + '"><video id="remoteVideo' + num + '" autoplay muted></video><audio autoplay></audio></div>');
    var remoteVideo = document.getElementById('remoteVideo' + num);
    room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
}

/**
 * 房间中发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
    console.log("=======================onUnpublishCameraNotify(),video:", video);
    video.unsubscrible();
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    console.log("=======================onUnsubscribleCameraResult(),userId:", userId);
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
    console.log("=======================onSubscribleMicrophoneResult(),userId:", userId);
    room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
}

/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
    console.log("=======================onUnsubscribleMicrophoneResult(),userId:", userId);
    room.selfUser.attachAudioElementMediaStream(remoteAudio, null);
}

//置忙
function setBusy() {
    var seatingAccount = $('#seatingAccount').val();
    if (seatingAccount == '') {
        $('#seatingStatusMsg').html('座席端帐号不能为空!');
        return
    }
    setSeatingStatus(seatingAccount, 1);
}

//置闲
function setLabor() {
    var seatingAccount = $('#seatingAccount').val();
    if (seatingAccount == '') {
        $('#seatingStatusMsg').html('座席端帐号不能为空!');
        return
    }
    setSeatingStatus(seatingAccount, 0);
}

function setSeatingStatus(seatingAccount, status) {
    var jsonObj = {
        "jsonrpc": "2.0",
        "id": "100",
        "method": "setSeatingStatus",
        "params": {
            "account": seatingAccount,
            "status": status
        }
    };

    rpcManager.call(jsonObj).then(function (result) {
        console.log("设置座席状态成功, result :", result);
        $('#seatingStatusMsg').html('设置座席状态成功!');
    }).otherwise(function (error) {
        console.log("设置座席状态失败。error:", error);
        $('#seatingStatusMsg').html('设置座席状态失败。error:' + error.message + "[" + error.code + "]");
    })
}


//获取可用的座席端
function getAvailableSeating() {
    var jsonObj = {
        "jsonrpc": "2.0",
        "id": "101",
        "method": "getAvailableSeating",
        "params": {}
    };

    rpcManager.call(jsonObj).then(function (result) {
        console.log("获取可用的座席端成功, result :", result);
        $('#availableSeatingMsg').html('获取可用的座席端成功,account:' + result.account);
    }).otherwise(function (error) {
        console.log("获取可用的座席端失败。error:", error);
        $('#availableSeatingMsg').html('获取可用的座席端失败。error:' + error.message + "[" + error.code + "]");
    })
}


function hangUp() {
    if (callInvite) {
        callInvite.close('hangUp').then(() => {
            console.log('callInvite.close()成功');
            leaveRoom();
        }).otherwise(() => {
            console.log('callInvite.close()失败');
        })
    }

    if (acceptInvite) {
        acceptInvite.close('hangUp').then(() => {
            console.log('acceptInvite.close()成功');
            leaveRoom();
        }).otherwise(() => {
            console.log('acceptInvite.close()失败');
        })
    }

}

//退会
function leaveRoom() {
	if(!room){
		return;
	}
    var reason = 1; //退会原因
    room.leave(reason).then(function () {
        window.location.reload();
    });

}