var serverURL = 'avd.nice2meet.cn:9630';
var accessKey = 'demo_access';
var secretKey = 'demo_secret';


var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 9000) + 1000);

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();

avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice();
avdEngine.checkDevice().then(checkResult).otherwise(checkError);
// avdEngine.setVideoCoding(VideoCodingType.H264);
var restApi = new RestApi(serverURL);

var isRoomOwer = false;
var self = this;

var localVideo = document.getElementById("localVideo");
var remoteAudio = document.getElementById("remoteAudio");
var remoteVideo = document.getElementById("remoteVideo");
var local_video = document.getElementById("local_video");
var local_audio = document.getElementById("local_audio");
var remote_video = document.getElementById("remote_video");
var remote_audio = document.getElementById("remote_audio");

var localVideoId = '';
var localAudioId = '';
var isOpenVideoShow = true;
var isOpenAudioShow = true;

var isVideoFacility = false
var isAudioFacility = false

var isFirstSafariAudio = false
var firstSafariAudioStream;

var playId = null;
var ttsCur = 0;

var ttss = [
  "https://dr-test.ai-rtc.com/v2.0.0/api/seat/upload/getFile/6c0b04af39bb4b56903cc6f9a8f81f8d?token=eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2MDgyNzA2NzB9.DtlN50U8k-a4uqBIrU9bysABqUFJctJPKTphX_km2lE",
  "https://dr-test.ai-rtc.com/v2.0.0/api/seat/upload/getFile/1f7f8ccc94d34ee4967fc45223541a14?token=eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2MDgyNjE0MzR9.ZuP-Mx9PfQTs8iaDgx7wmzWD5T4DbWnAzntz_4iD9vo",
  "https://dr-test.ai-rtc.com/v2.0.0/api/seat/upload/getFile/45c9ac9011ab48609043a81abf7a248f?token=eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2MDgyNjE0MzZ9.3cqXeWYgmk9fw7AGyT1yj6cmkxlkp4MSxa3Pg5m-oE8",
];


restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('Success', res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error", error);
    $(".promptMsg").html('getAccessToken(),error:' + error.msg);

})

function checkResult(result) {
    isVideoFacility = result.video;
    isAudioFacility = result.audio;
}

function checkError(error) {
    $(".promptMsg").html("get device error!error code:" + error.code + "; error message:" + error.message);
}

//创建房间
function createRoom() {
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        console.log('Success', res)
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        console.log("Error", error)
        $(".promptMsg").html('createRoom(),error:' + error.msg);
    })
}

//  加入会议
function joinRoom() {
    if (room) { return }
    if (!isVideoFacility) {
        $('.promptMsg').html('没有摄像头设备，请插入');
    } else if (!isAudioFacility) {
        $('.promptMsg').html('没有音频设备，请插入');
    } else if ($("#first").val() == '') {
        $('.promptMsg').html('会议号不能为空，请先创建房间');
    } else {
        self.roomId = $("#first").val();
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

//  初始化成功
function initSuccess() {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//  初始化失败
function initError(error) {
    $(".promptMsg").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('加入会议成功');

    //  自动打开音视频
    openCamera();
    openMicrophone();

    //注册房间回调
    registerRoomCallback();

    //加会登陆前，会议中已经发布的视频资源,采取订阅处理
    onPublishCameraNotify(room.pubVideos);

    participantsHandle(room.getParticipants());

    $('.localVideo_userName').html(self.userName);
}

//  加入房间失败
function joinError(error) {
    console.log('==================joinError(),error:', error)
    if (error.code == 404) {
        $(".promptMsg").html("加会失败！原因房间没有找到，请核实。joinError(),error");
    } else {
        $(".promptMsg").html('joinError(),error:' + error.message + "[" + error.code + "]");
    }
}

/**
 * 打开摄像头
 */
function openCamera() {
    if (isOpenVideoShow) {
        isOpenVideoShow = false;
        videos = room.selfUser.videos;
        if (videos && videos.length > 0) {
            var video = videos[0];
            if (video) {
                localVideoId = video.id;
                video.previewAndPublish(localVideo).otherwise(showError);
                local_video.className = 'openCamera';
            }
        }
    }
}

/**
 * 关闭摄像头
 */
function closeCamera() {
    if (!isOpenVideoShow) {
        isOpenVideoShow = true;
        var video = room.selfUser.getVideo(self.localVideoId);
        if (video) {
            local_video.className = 'closeCamera';
            video.unpreview();
            video.unpublish();
        }
    }
}

/**
 * 打开麦克风
 */
function openMicrophone() {
    console.log(`+++123openMicrophone`);
    if (isOpenAudioShow) {
        isOpenAudioShow = false;
        var audio = room.selfUser.audio;
        localAudioId = audio.id;
        if (audio) {
            audio.openMicrophone().otherwise(showError);
            local_audio.className = 'openMicrophone';
        }
    }
}



/**
 * 麦克风静音
 */
function muteMicrophone() {
    if (!isOpenAudioShow) {
        isOpenAudioShow = true;
        var audio = room.selfUser.getAudio(self.localAudioId);
        if (audio) {
            local_audio.className = 'closeMicrophone';
            audio.muteMicrophone();
        }
    }
}

function unmuteMicrophone(){
    if(isOpenAudioShow){
        isOpenAudioShow = false;
        var audio = room.selfUser.audio;
        if(audio && audio.status == StreamStatus.muted){
            audio.unmuteMicrophone();
            local_audio.className = 'openMicrophone';
        }
    }
}

function showError(error) {
    $(".promptMsg").html('showError(),error:' + error.message + "[" + error.code + "]");
}

//退会
function leaveRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
		
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
		
		if(room.connectionStatistics){
			room.connectionStatistics.stop(); //停止上报媒体信息
		}
		
        var reason = 1; //退会原因
        room.leave(reason).then(function () {
            //top.location = "index.html";
            //return false;
			
			//前端变量清场
			localVideoId = '';
		    localAudioId = '';
			isOpenVideoShow = true;
			isOpenAudioShow = true;
			
			isFirstSafariAudio = false;
			
			$('.localVideo_userName').html('');
			remote_video.className = '';
			remote_audio.className = '';
			
			$('.remoteVideo_userName').html('');
			
			roomId = null;
			playId = null;
			ttsCur = 0;
			$("#first").val('');
			
        });
    }
}

//注册房间回调
function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
	
	room.addCallback(RoomCallback.mediaplay_started_notify, onMediaPlayStartedNotify);
	room.addCallback(RoomCallback.mediaplay_stoped_notify, onMediaPlayStopedNotify);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".promptMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".promptMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".promptMsg").html("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    console.log("============onUserJoinNotify(),users:", users);
    participantsHandle(users);
}

/**
 * @desc 参会者退会回调
 */
function onUserLeaveNotify() {
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
    $('.remoteVideo_userName').html('');
    remote_video.className = '';
    remote_audio.className = '';
}

/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {
    participants.forEach(function (user) {
        user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
        user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);

        user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
        user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
        user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
        user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);

        user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
        user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);
    })
}

/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            local_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            local_audio.className = 'closeMicrophone';
        }
    } else {
        if (status == StreamStatus.published) {
            remote_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            remote_audio.className = 'closeMicrophone';
        }
    }
}

/**
 * 房间中发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
    video.unsubscrible();
}

/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            local_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            local_video.className = 'closeCamera';
        }
    } else {
        if (status == StreamStatus.published) {
            remote_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            remote_video.className = 'closeCamera';
        }
    }
}

//订阅未订阅的视频
function onPublishCameraNotify(videos) {
    videos.forEach(function (video) {
        //只订阅未订阅过的视频
        var subVideoIdsLen = room.selfUser.subVideoIds.length;
        if (subVideoIdsLen > 0) {
            var isSub = false;
            for (var i = 0; i < subVideoIdsLen; i++) {
                var videoId = room.selfUser.subVideoIds[i];
                if (video.id == videoId) {
                    isSub = true;
                    break;
                }
            }
            if (!isSub) {
                video.subscrible();
            }
        } else {
            video.subscrible();
        }
    });
}

/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
    $('.remoteVideo_userName').html(userName);
    remote_video.className = 'openCamera';
    room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
    log.info(`+++123, onSubscribleMicrophoneResult, ${userName}'s microphone stream ${stream}`);
    remote_audio.className = 'openMicrophone';
    var remoteAudio = document.getElementById('remoteAudio');
    if(room.avdEngine.isSafari){
        if(isFirstSafariAudio && remoteAudio){
            room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
        }
        else{
            isFirstSafariAudio = true;
            firstSafariAudioStream = stream;
            $('.safariAudioNotice').show();
        }
    }
    else{
        room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
    }
}

function safariAudioHandle(){
    $('.safariAudioNotice').hide();
    var remoteAudio = document.getElementById('remoteAudio');
    if(remoteAudio){
        room.selfUser.attachAudioElementMediaStream(remoteAudio, firstSafariAudioStream);
    }
}

/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
    room.selfUser.attachAudioElementMediaStream(remoteAudio, null);
}


function create(){
	restApi.mediaCreate(self.accessToken, roomId, "tts","rtsp_4").then((res) => {
		playId = res.play_id;
	    console.log('media Create Success', res);
	}).otherwise((error) => {
	    alert("media Create  Error", error)
	});
}

function play(num){
	if(!num){
	   ttsCur = 0;
	}
	restApi.mediaPlay(self.accessToken,roomId, playId,ttss[ttsCur]).then((res) => {
	    console.log('media play Success', res);
	}).otherwise((error) => {
	    alert("media play  Error", error)
	});
	
}

function stop(){
	restApi.mediaStop(self.accessToken, roomId, playId).then((res) => {
		console.log('media stop Success', res);
	}).otherwise((error) => {
		alert("media stop  Error", error)
	});
}



/**
 * 媒体播放开始通知
 * @param {string} id -信令Id
 * @param {string} roomId -房间号
 * @param {string} userId - 用户Id
 * @param {string} playId - 播放器Id
 * @param {string} filePath - 媒体文件路径
 */
function onMediaPlayStartedNotify(id,roomId,userId,playId,filePath){
   console.log("+++onMediaPlayStartedNotify(),roomId:"+roomId+",userId:"+userId+",playId:"+playId+",filePath:"+filePath);
}

/**
 * 媒体播放结束通知
 * @param {string} id -信令Id
 * @param {string} roomId -房间号
 * @param {string} userId - 用户Id
 * @param {string} playId - 播放器Id
 * @param {string} filePath - 媒体文件路径
 */	
function onMediaPlayStopedNotify(id,roomId,userId,playId,filePath){
	console.log("+++onMediaPlayStopedNotify(),roomId:"+roomId+",userId:"+userId+",playId:"+playId+",filePath:"+filePath); 
	setTimeout(function(){
		ttsCur = ttsCur +1;
		if(ttsCur < ttss.length){
			play(ttsCur);
		}
	},3000)
}

