//本地工程环境运行时会走http协议，用dev.3tee.cn:81， nodejs环境运行时会走https协议，用dev.3tee.cn:441
var serverURL = 'avd.nice2meet.cn:9609';

var accessKey = 'demo_access';
var secretKey = 'demo_secret';

var roomId = '';
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 9000) + 1000);
var accessToken = '';

var publish_url = '';
var rtmp_url = '';
var hls_url = '';

var restApi = new RestApi(serverURL);

var localVideo = document.getElementById("localVideo");
var shareVideo = document.getElementById("shareVideo");


var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();

avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice();
avdEngine.setVideoCoding(VideoCodingType.H264);

var streamExporterManager = avdEngine.getStreamExporterManager();
var screen = null;
var self = this;

document.getElementById("openDesktopShared").disabled = 'ture';
document.getElementById("live").disabled = 'ture';
document.getElementById("watchLive").disabled = 'ture';
document.getElementById("exitMeeting").disabled = 'ture';

//	获取房间Token
restApi.getAccessToken(self.accessKey, self.secretKey).then((res) => {
    console.log(res);
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log(error);
    $(".prompt p").html('getAccessToken(),error:'+ error.msg);

})

//创建房间
function createRoom() {
    $(".prompt p").html('')
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        $(".prompt p").html('createRoom(),error:'+error.msg);
    })
}

//  点击加入房间
function joinRoom() {
    if (room) { return }
    if ($("#first").val() == '') {
        $(".prompt p").html('会议号不能为空，建议请先创建房间');
    } else {
        self.roomId = $("#first").val();
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

//  初始化成功
function initSuccess() {
    room = avdEngine.obtainRoom(roomId);
    room.join(userId, userName, '', '').then(joinSuccess).otherwise(joinError);
    $(".prompt p").html('');
}

//  初始化失败
function initError(error) {
    console.log(error)
    $(".prompt p").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('加入会议成功');

    //自动打开音视频
    openCameraAndPubVideo();
    openMicrophone();

    //房间回调
    registerRoomCallback();

    onPublishScreenNotify(room.pubScreens);
    participantsHandle(room.getParticipants());

    document.getElementById("joinMeeting").disabled = '';
    document.getElementById("joinMeeting").className = 'unclickable';
    document.getElementById("openDesktopShared").disabled = '';
    document.getElementById("openDesktopShared").className = 'clickable';
    document.getElementById("exitMeeting").disabled = '';
    document.getElementById("exitMeeting").className = 'clickable';
}

//  加入房间失败
function joinError(error) {
    $(".prompt p").html(error.message);
}

/**
 * 预览摄像头及发布流
 */
function openCameraAndPubVideo() {
    videos = room.selfUser.videos;
    console.log(room.selfUser.videos)
    if (videos && videos.length > 0) {
        var video = videos[0];
        video.previewAndPublish(localVideo).otherwise(alertError);
    }
}

function alertError(error) {
    console.log("============================alertError", error)
    $(".prompt p").html('alertError(),error:'+ error.message);
}

/**
 * 打开麦克风
 */
function openMicrophone() {
    var audio = room.selfUser.audio;
    if (audio) {
        audio.openMicrophone().otherwise(alertError);
    }
}

/**
 * 注册房间级别的回调
 */
function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);
    room.addCallback(RoomCallback.screen_sharing_ended, onScreenSharingEnded);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
	participantsHandle(users);
}

//  网络状态
function onConnectionStatus(status) {
    console.log("=====================onConnectionStatus()", status)
    if (status == ConnectionStatus.connecting) {
        $(".prompt p").html("网络故障,正在与服务器重连中...");
    } else if (status == ConnectionStatus.connected) {
        //连接成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.reJoinConnected) {
        //重新加会成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.reconnected) {
        //重连接成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.connectFailed) {
        $(".prompt p").html("网络故障,与服务器重连超时，正在重新加会操作中...");
    } else if (status == ConnectionStatus.reJoinRoomTimeOut) {
        $(".prompt p").html("网络故障,重新加会中...");
    }
}

// 桌面共享关闭的回调
function onScreenSharingEnded() {
    log.info('onScreenStatusNotify(),退出Picture-in-Picture模式...');
    try {
        // 退出画中画
        document.exitPictureInPicture();
        document.getElementById("openDesktopShared").disabled = '';
        document.getElementById("openDesktopShared").className = 'clickable';
        document.getElementById("live").disabled = 'true';
        document.getElementById("live").className = 'unclickable';
        
        document.getElementById("watchLive").disabled = 'true';
        document.getElementById("watchLive").className = 'unclickable';

    } catch (error) {
        console.log('onScreenStatusNotify(),退出Picture-in-Picture模式出错了:' + error);
        $(".prompt p").html("onScreenStatusNotify(),退出Picture-in-Picture模式出错了:" + error);
    } finally {

    }
}

//  打开桌面共享
function openScreenAndPub() {
    if (!room) { return }
    screen = room.selfUser.getScreen();
    console.log("========================================", screen.id)
    if (screen) {
        screen.publish().then(function () {
            console.log('=============openScreenAndPub(),桌面共享成功==========');
            log.info('openScreenAndPub(),切换Picture-in-Picture模式...');
            try {
                if (localVideo !== document.pictureInPictureElement) {
                    // 尝试进入画中画模式
                    localVideo.requestPictureInPicture().then(function () {
                        if (document.movePictureInPicture && document.resizePictureInPicture) {
                            document.movePictureInPicture(0, 0);
                            document.resizePictureInPicture(200, 200);
                        }
                    });
                } else {
                    // 退出画中画
                    document.exitPictureInPicture();
                }
            } catch (error) {
                console.log('openScreenAndPub(),Picture-in-Picture模式出错了:' + error);
                $(".prompt p").html("openScreenAndPub(),Picture-in-Picture模式出错了:" + error);
            } finally {

            }

        }).otherwise(alertError);

        document.getElementById("openDesktopShared").disabled = 'ture';
        document.getElementById("openDesktopShared").className = 'unclickable';
        document.getElementById("live").disabled = '';
        document.getElementById("live").className = 'clickable';
    }
}

/**
 * 创建直播服务
 */
var livecastStreamExporterServer = null;
function createServerLivecast() {
    if (!screen) { return }
    var name = "ds_Livecast";
    var viewWidth = 640;
    var viewHeight = 480;
    var outBitrate = 500;
    var outFps = 25;
    var maxVideoNumber = 10;
    var pulish_urls = "";

    if (publish_url && rtmp_url) {
        var temp = new Object();
        temp.publish_url = publish_url;
        temp.rtmp_url = rtmp_url;
        temp.hls_url = hls_url;

        pulish_urls = JSON.stringify(temp);
    }
    console.log("===========createServerLivecast()", pulish_urls)
    console.log("========================================", screen.id)

    streamExporterManager.createServerLivecast(name, viewWidth, viewHeight, outBitrate, outFps, maxVideoNumber, pulish_urls).then(function (streamExporterServer) {
        livecastStreamExporterServer = streamExporterServer;
        console.log("++++++++++livecastStreamExporterServer:", livecastStreamExporterServer);
        livecastStreamExporterServer.selectSingleVideo4Exporter(room.selfUser.id, screen.id, room.selfUser.id, '').then(function (data) {
            console.log("===============selectSingleVideo4Exporter(),data:", data);
            document.getElementById("live").disabled = 'true';
            document.getElementById("live").className = 'unclickable';
            document.getElementById("watchLive").disabled = '';
            document.getElementById("watchLive").className = 'clickable';
        }).otherwise(function (error) {
            console.log("selectSingleVideo4Exporter(),error:", error);
            $(".prompt p").html("selectSingleVideo4Exporter(),error:" + error.message);
        });

    }).otherwise(function (error) {
        console.log("createServerLivecast(),error:", error);
        $(".prompt p").html('createServerLivecast(),error:'+ error.message);
    });
}

function participantsHandle(participants) {
    participants.forEach(function(user) {
        user.addCallback(UserCallback.publish_screen_notify, onPublishScreenNotify);
		user.addCallback(UserCallback.unpublish_screen_notify, onUnpublishScreenNotify);
		user.addCallback(UserCallback.subscrible_screen_result, onSubscribleScreenResult);
		user.addCallback(UserCallback.unsubscrible_screen_result, onUnsubscribleScreenResult);
    })
}

function onPublishScreenNotify(screens) {
	screens.forEach(function(screen) {
		//只订阅未订阅过的桌面共享
		var subScreenIdsLen = room.selfUser.subScreenIds.length;
		if(subScreenIdsLen > 0) {
			for(var i = 0; i < subScreenIdsLen; i++) {
				var screenId = room.selfUser.subScreenIds[i];
				if(screen.id == screenId) {
					isSub = true;
					break;
				}
			}
			if(!isSub) {
				screen.subscrible();
			}
		} else {
			screen.subscrible();
		}
	});
}

function onUnpublishScreenNotify(screen) {
	screen.unsubscrible();
}

function onSubscribleScreenResult(stream, userId, userName, screenId, width, height,framerate) {
	console.log("=======onSubscribleScreenResult(),width:"+  width + ",height:" + height+",framerate:"+framerate);
	room.selfUser.attachScreenElementMediaStream(shareVideo, stream);
}

function onUnsubscribleScreenResult(userId, userName, screenId) {
	room.selfUser.attachScreenElementMediaStream(shareVideo, null);
}

/**
 *  退出会议室
 */
function closeRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
        var reason = 1; //退会原因
        room.leave(reason).then(function () {
            top.location = "index.html";
            return false;
        });
    }
}

function watchLive() {
    if (!livecastStreamExporterServer) { return }
    if (livecastStreamExporterServer.playurls) {
        var liveUrl = JSON.parse(livecastStreamExporterServer.playurls)
        console.log("======================watchLive()", liveUrl.rtmp_url)
    }
    window.open('aliplayer.html?src=' + liveUrl.rtmp_url)
}