//本地工程环境运行时会走http协议，用dev.3tee.cn:81， nodejs环境运行时会走https协议，用dev.3tee.cn:441
var serverURL = 'dev.3tee.cn:81';
var accessKey = 'sdk2020_demo_access';
var secretKey = 'sdk2020_demo_secret';


// var serverURL = 'avd.nice2meet.cn:9609';
// var accessKey = 'SDKdemo_access';
// var secretKey = 'SDKdemo_secret';
var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 9000) + 1000);

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
var avdEngine = new AVDEngine();

avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice();
avdEngine.setVideoCoding(VideoCodingType.H264);

var restApi = new RestApi(serverURL);
var streamExporterManager = avdEngine.getStreamExporterManager();
var self = this;

var localVideo = document.getElementById('localVideo');

$("#join").attr('disabled', true);
$("#leave").attr('disabled', true);
$('.content button').attr('disabled', true);
$('.modelChoose input').attr('disabled', true);

var layoutModels = [
    {
        modelName: '3分屏',
        modelNum: 3,
        modelType: 1,
        coordinate: [
            {
                x: 0,
                y: 0,
                w: 0.7,
                h: 1,
                zorder: 0
            },
            {
                x: 0.7,
                y: 0,
                w: 0.3,
                h: 0.5,
                zorder: 0
            },
            {
                x: 0.7,
                y: 0.5,
                w: 0.3,
                h: 0.5,
                zorder: 0
            }
        ]
    },
    {
        modelName: '4分屏',
        modelNum: 4,
        modelType: 1,
        coordinate: [
            {
                x: 0,
                y: 0,
                w: 0.5,
                h: 0.5,
                zorder: 0
            },
            {
                x: 0.5,
                y: 0,
                w: 0.5,
                h: 0.5,
                zorder: 0
            },
            {
                x: 0,
                y: 0.5,
                w: 0.5,
                h: 0.5,
                zorder: 0
            },
            {
                x: 0.5,
                y: 0.5,
                w: 0.5,
                h: 0.5,
                zorder: 0
            }
        ]
    },

    {
        modelName: '演讲者1',
        modelNum: 4,
        modelType: 2,
        coordinate: [
            {
                x: 0,
                y: 0,
                w: 1,
                h: 1,
                zorder: 0
            },
            {
                x: 0.2,
                y: 0.75,
                w: 0.2,
                h: 0.2,
                zorder: 1
            },
            {
                x: 0.4,
                y: 0.75,
                w: 0.2,
                h: 0.2,
                zorder: 1
            },
            {
                x: 0.6,
                y: 0.75,
                w: 0.2,
                h: 0.2,
                zorder: 1
            }
        ]
    },
    {
        modelName: '演讲者2',
        modelNum: 4,
        modelType: 2,
        coordinate: [
            {
                x: 0,
                y: 0,
                w: 1,
                h: 1,
                zorder: 0
            },
            {
                x: 0.75,
                y: 0.2,
                w: 0.2,
                h: 0.2,
                zorder: 1
            },
            {
                x: 0.75,
                y: 0.4,
                w: 0.2,
                h: 0.2,
                zorder: 1
            },
            {
                x: 0.75,
                y: 0.6,
                w: 0.2,
                h: 0.2,
                zorder: 1
            }
        ]
    },

    {
        modelName: '自动画廊',
        modelNum: 99,
        modelType: 3
    },
    {
        modelName: '自动演讲者',
        modelNum: 99,
        modelType: 4
    },

];
var participant = [];

var currentLayoutModelType = 2;

//获取token
restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('Success', res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error", error);
    if (error.ret == 10000) {
        $(".promptMsg").html(error.msg + '  查看协议是否为https,如果是则更换serverURL地址');
    } else {
        $(".promptMsg").html(error.msg);
    }
})

//创建房间
function createRoom() {
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        console.log('Success', res)
        $("#first").val(res.room_id);
        $("#join").attr('disabled', false);
    }).otherwise((error) => {
        console.log("Error", error)
        $(".promptMsg").html(error.msg);
    })
}

//  加入会议
function joinRoom() {
    if (room) { return }
    if ($("#first").val() == '') {
        $(".promptMsg").html('会议号不能为空，请先创建房间');
    } else {
        self.roomId = $("#first").val();
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

//  初始化成功
function initSuccess() {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//  初始化失败
function initError(error) {
    $(".promptMsg").html("AVDEngine 初始化失败！initError()" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('加入会议成功');
    $("#leave").attr('disabled', false);
    $('.content button').attr('disabled', false);
    $('.modelChoose input').attr('disabled', false);

    //  自动打开音视频
    openCamera();
    openMicrophone();

    //房间回调
    registerRoomCallback();

    participants = room.getParticipants();
    console.log('111111111111111111', participants)
    for (var i = 0; i < participants.length; i++) {
        $("#audioSet").append('<option value=' + participants[i].id + ' ' + 'class=' + participants[i].id + '>' + participants[i].name + '--' + participants[i].id + '</option>');
        $("#singleAudioSet").append('<option value=' + participants[i].id + ' ' + 'class=' + participants[i].id + '>' + participants[i].name + '--' + participants[i].id + '</option>');
        $("#singleAppointVideo").append('<option value=' + participants[i].videos[0].id + ' ' + 'class=' + participants[i].id + '>' + participants[i].name + '--' + participants[i].id + '</option>');
        $("#screenShow").append('<option value=' + participants[i].id + ' ' + 'class=' + participants[i].id + '>' + participants[i].name + '--' + participants[i].id + '</option>');
        $(".userList").append('<option id=' + participants[i].id + ' ' + 'value=' + participants[i].videos[0].id + ' ' + 'class=' + participants[i].name + '>' + participants[i].name + '--' + participants[i].id + '--' + '</option>');
    }

}

//  加入房间失败
function joinError(error) {
    if (error.code == 404) {
        $(".promptMsg").html("加会失败！原因房间没有找到，请核实。joinError()");
    } else {
        $(".promptMsg").html('joinError(),' + error.message + "[" + error.code + "]");
    }
}

//退会
function leaveRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
        var reason = 1; //退会原因
        room.leave(reason).then(function () {
            top.location = "index.html";
            return false;
        });
    }
}


/**
 * 打开摄像头
 */
function openCamera() {
    videos = room.selfUser.videos;
    if (videos && videos.length > 0) {
        var video = videos[0];
        if (video) {
            localVideoId = video.id;
            video.publish().otherwise(showError);
            // video.previewAndPublish(localVideo).otherwise(showError);
        }
    }
}

/**
 * 打开麦克风
 */
function openMicrophone() {
    var audio = room.selfUser.audio;
    if (audio) {
        audio.openMicrophone().otherwise(showError);
    }
}

function showError(error) {
    $(".promptMsg").html('showError(),' + error.message + "[" + error.code + "]");
}

if ($('#appChoose').val() == 1) {
    $('.show').css({ 'display': 'block' });
    $('.pushAddress').css('display', 'inline-block');
}

$('#appChoose').click(function () {
    if ($('#appChoose').val() != 1) {
        $('.show').css('display', 'none');
        $('.pushAddress').css('display', 'none');
    } else {
        $('.show').css({ 'display': 'block' });
        $('.pushAddress').css('display', 'inline-block');
        $('.liveName').html('直播名称:');
        $('.live').css('display', 'block');
        $('.recording').css('display', 'none');
        $('.screen').css('display', 'none');
    }
    if ($('#appChoose').val() == 2) {
        $('.liveName').html('录制名称:');
        $('.live').css('display', 'none');
        $('.recording').css('display', 'block');
        $('.screen').css('display', 'none');
    }
    if ($('#appChoose').val() == 3) {
        $('.liveName').html('合屏名称:');
        $('.live').css('display', 'none');
        $('.recording').css('display', 'none');
        $('.screen').css('display', 'block');
    }
})

/**
 * 注册房间级别的回调
 */
function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".promptMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".promptMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".promptMsg").html("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    $("#singleAudioSet").append("<option class=" + users[0].id + ' ' + "value=" + users[0].id + ">" + users[0].name + '--' + users[0].id + "</option>");
    $("#audioSet").append("<option class=" + users[0].id + ' ' + "value=" + users[0].id + ">" + users[0].name + '--' + users[0].id + "</option>");
    $("#singleAppointVideo").append("<option class=" + users[0].id + ' ' + "value=" + users[0].id + ">" + users[0].name + '--' + users[0].id + "</option>");
    $("#screenShow").append("<option class=" + users[0].id + ' ' + "value=" + users[0].id + ">" + users[0].name + '--' + users[0].id + "</option>");
    // $(".userList").append("<option class=" + users[0].id + ' ' + "value=" + users[0].id + ">" + users[0].name + '--' + users[0].id + "</option>");
    $(".userList").append('<option id=' + users[0].videos[0].id + ' ' + 'value=' + users[0].id + ' ' + 'class=' + users[0].name + '>' + users[0].name + '--' + users[0].id + '</option>');

}

/**
 * @desc 参会者退会回调
 * @param {int} opt - 退会类型
 * @param {int} reason  - 退会原因
 * @param {Object} user - 退会用户
 */
function onUserLeaveNotify(opt, reason, user) {
    $("#singleAudioSet").remove("option[value=" + user.id + "]");
    $("#audioSet").remove("option[value=" + user.id + "]");
    $("#singleAppointVideo").remove("option[value=" + user.id + "]");
    $("#screenShow").remove("option[value=" + user.id + "]");
    $(".userList option").remove("option[id=" + user.id + "]");
}



//创建直播
var liveStreamServer = null;
function createServerLivecast() {
    var name = 'ds_Livecast';
    var arr = $('#videoWH').val().split("x");
    var viewWidth = parseInt(arr[0]);
    var viewHeight = parseInt(arr[1]);
    var outBitrate = parseInt($('#stream').val());
    var outFps = parseInt($('#frameRate').val());
    var maxVideoNumber = 10;
    var publish_url = $('#pushAddress').val();
    var rtmp_url = $('#liveRTMP').val();
    var hls_url = $('#liveHLS').val();
    var pulish_urls = "";

    if (publish_url && rtmp_url) {
        var temp = new Object();
        temp.publish_url = publish_url;
        temp.rtmp_url = rtmp_url;
        temp.hls_url = hls_url;

        pulish_urls = JSON.stringify(temp);
    }
    // if(!publish_url) {
    //     $('.promptMsg').html('直播推流地址不能为空');
    //     return
    // }
    // if(!rtmp_url) {
    //     $('.promptMsg').html('直播RTMP播放地址不能为空');
    //     return
    // }
    if ($('#liveName').val() != "") {
        name = $('#liveName').val();
    }

    streamExporterManager.createServerLivecast(name, viewWidth, viewHeight, outBitrate, outFps, maxVideoNumber, pulish_urls).then((streamExporterServer) => {
        liveStreamServer = streamExporterServer;
        console.log("===============createServerLivecast(),streamExporterServer:", liveStreamServer);

        $('.modelChoose input').attr('disabled', true);

        if (liveStreamServer.playurls) {
            var playurlsObj = JSON.parse(liveStreamServer.playurls);
            $('#pushAddress').val(playurlsObj.publish_url);
            $('#liveRTMP').val(playurlsObj.rtmp_url);
            $('#liveHLS').val(playurlsObj.hls_url);
            $('#liveName').val(name);
        }
        if ($('#single')[0].checked) {
            if (localVideoId) {
                var deviceId = $('#singleAppointVideo').val();
                var audioUserId = $('#singleAudioSet').val();
                liveStreamServer.selectSingleVideo4Exporter(room.selfUser.id, deviceId, audioUserId).then((data) => {

                    $('#singleAudioSet').val(audioUserId);
                    $('#singleAppointVideo').val(deviceId);
                    $('.setting_single').css('display', 'block');
                    $('.setting_more').css('display', 'none');
                    $(".createLive").attr('disabled', true);
                    console.log("===============selectSingleVideo4Exporter(),data:", data);
                }).otherwise((error) => {
                    $('.promptMsg').html("selectSingleVideo4Exporter(),error:" + error);
                })
            } else {
                $(".createLive").attr('disabled', false);
                $('.promptMsg').html("请先打开本地摄像头");
                return
            }
        } else if ($('#more')[0].checked) {
            // if (self.currentLayoutModelItems.length) {
            //     for (var i = 0; i < self.currentLayoutModelItems.length; i++) {

            //         var userId = self.currentLayoutModelItems[i].userId;
            //         var deviceId = self.currentLayoutModelItems[i].deviceId;
            //         var x = self.currentLayoutModelItems[i].x;
            //         var y = self.currentLayoutModelItems[i].y;
            //         var width = self.currentLayoutModelItems[i].w;
            //         var height = self.currentLayoutModelItems[i].h;
            //         var zorder = self.currentLayoutModelItems[i].zorder;

            //         console.log("=====000000=========saveLayout(),userId, deviceId, x, y, width, height, zorder:", userId, deviceId, x, y, width, height, zorder)
            //         liveStreamServer.addVideoItem(userId, deviceId, x, y, width, height, zorder, "", "").then(function () {
            //             console.log("addVideoItem(),success");
            //         }).otherwise(function (error) {
            //             console.log("toAddVideoItem(),error:", error);
            //         });

            //     }
            // }


            // if (currentLayoutModelType == 1) {
            //     liveStreamServer.viewLayoutMode = viewLayoutModeEnum.fixation;
            // } else if (currentLayoutModelType == 2) {
            //     liveStreamServer.viewLayoutMode = viewLayoutModeEnum.auto;
            // } else if (currentLayoutModelType == 3) {
            //     liveStreamServer.viewLayoutMode = viewLayoutModeEnum.auto_orato;
            //     // liveStreamServer.setFocusVideo().then(function(){}).otherwise(function(){})
            // } else {
            //     liveStreamServer.viewLayoutMode = liveStreamServer.viewLayoutMode;
            // }
            // console.log('================liveStreamServer:', liveStreamServer)
            // liveStreamServer.selectMixedVideos4Exporter().then((data) => {
            //     $('.setting_single').css('display', 'none');
            //     $('.setting_more').css('display', 'block');
            //     $(".createLive").attr('disabled', true);
            //     console.log('===========================selectMixedVideos4Exporter()', data);
            // }).otherwise((error) => {
            //     $('.setting_single').css('display', 'none');
            //     $('.setting_more').css('display', 'none');
            //     $(".createLive").attr('disabled', false);
            //     $('.promptMsg').html("selectMixedVideos4Exporter(),error:" + error);
            // })
        }
    }).otherwise((error) => {
        $('.promptMsg').html("createServerLivecast(),error:" + error);
        $('.modelChoose input').attr('disabled', false);
    })
}

//停止直播
function stopExporter() {
    if (!liveStreamServer) { return }
    $('.modelChoose input').attr('disabled', false);
    $('.createLive').attr('disabled', false);
    liveStreamServer.stopExporter().then((data) => {
        $('#createLive').removeClass('unclick');
        $("#createLive").attr('disabled', false);
        console.log('================================stopLive()', data)
    }).otherwise((error) => {
        $('.promptMsg').html("stopLive(),error:" + error);
    })
}

//观看直播
function watchLive() {
    if (!liveStreamServer) { return }
    if (liveStreamServer.playurls) {
        var liveUrl = JSON.parse(liveStreamServer.playurls)
        console.log("======================watchLive()", liveUrl)
    }
    window.open('aliplayer.html?src=' + liveUrl.rtmp_url)
}

//创建录制
var recorderStreamServer = null;
function createServerRecorder() {
    var name = 'ds_Livecast';
    var arr = $('#videoWH').val().split("x");
    var viewWidth = parseInt(arr[0]);
    var viewHeight = parseInt(arr[1]);
    var outBitrate = parseInt($('#stream').val());
    var outFps = parseInt($('#frameRate').val());
    var maxVideoNumber = 10;
    var publish_url = $('#pushAddress').val();
    var rtmp_url = $('#liveRTMP').val();
    var hls_url = $('#liveHLS').val();
    var pulish_urls = "";

    if ($('#liveName').val() != "") {
        name = $('#liveName').val();
    }

    if (publish_url && rtmp_url) {
        var temp = new Object();
        temp.publish_url = publish_url;
        temp.rtmp_url = rtmp_url;
        temp.hls_url = hls_url;

        pulish_urls = JSON.stringify(temp);
    }
    console.log('===============', room.selfUser.id)
    streamExporterManager.createServerRecorder(name, viewWidth, viewHeight, outBitrate, outFps, maxVideoNumber, pulish_urls).then((streamExporterServer) => {
        console.log('===========================createServerRecorder()', streamExporterServer)
        recorderStreamServer = streamExporterServer;
        $('.modelChoose input').attr('disabled', true);
        if ($('#single')[0].checked) {
            if (localVideoId) {
                var deviceId = $('#singleAppointVideo').val();
                var audioUserId = $('#singleAudioSet').val();
                recorderStreamServer.selectSingleVideo4Exporter(room.selfUser.id, deviceId, audioUserId).then((data) => {
                    $('#singleAudioSet').val(audioUserId);
                    $('#singleAppointVideo').val(deviceId);
                    $('.setting_single').css('display', 'block');
                    $('.setting_more').css('display', 'none');
                    $(".createRecorder").attr('disabled', true);
                    console.log("===============selectSingleVideo4Exporter(),data:", data);
                }).otherwise((error) => {
                    $('.promptMsg').html("selectSingleVideo4Exporter(),error:" + error);
                })
            } else {
                $(".createRecorder").attr('disabled', false);
                $('.promptMsg').html("请先打开本地摄像头");
                return
            }
        } else if ($('#more')[0].checked) {
            // recorderStreamServer.selectMixedVideos4Exporter().then((data) => {
            //     $('.setting_single').css('display', 'none');
            //     $('.setting_more').css('display', 'block');
            //     $(".createRecorder").attr('disabled', true);
            //     console.log('===========================selectMixedVideos4Exporter()', data);
            // }).otherwise((error) => {
            //     $('.setting_single').css('display', 'none');
            //     $('.setting_more').css('display', 'none');
            //     $(".createRecorder").attr('disabled', false);
            //     $('.promptMsg').html("selectMixedVideos4Exporter(),error:" + error);
            // })
        }
    }).otherwise((error) => {
        $('.promptMsg').html("createServerRecorder(),error:" + error);
        $('.modelChoose input').attr('disabled', false);
    })
}

//停止录制
function stopRecorder() {
    if (!recorderStreamServer) { return }
    $('.modelChoose input').attr('disabled', false);
    $('.createRecorder').attr('disabled', false);
    recorderStreamServer.stopExporter().then((data) => {
        $('#createRecorder').removeClass('unclick');
        $("#createRecorder").attr('disabled', false);
        console.log('================================stopRecorder()', data)
    }).otherwise((error) => {
        $('.promptMsg').html("stopRecorder(),error:" + error);
    })
}

//观看录制
function watchRecorder() {
    if (!recorderStreamServer) { return }
    console.log(restApi)
    restApi.queryRoomRecording(self.accessToken, self.roomId, '', '').then((res) => {
        if (res.record_files[0].transcode_files.play_url[0]) {
            window.open(res.record_files[0].transcode_files.play_url[0])
        }
    }).otherwise((error) => {
        console.log("================watchRecorder()", error)
        if (error = "Cannot read property '0' of undefined") {
            $('.promptMsg').html('请稍等，视频正在转码中...')
        } else {
            $('.promptMsg').html("watchRecorder(),error:" + error);
        }
    })
}

//选择布局
if ($("#chooseLayout").val() == 1) {
    $('.auto').css('display', 'block');
    $('.manualGallery').css('display', 'none');
    $('.manualSpeakerl').css('display', 'none');
}

$('#chooseLayout').click(function () {
    if ($("#chooseLayout").val() == 1) {
        $('.auto').css('display', 'block');
        $('.manualGallery').css('display', 'none');
        $('.manualSpeakerl').css('display', 'none');
    }
    if ($("#chooseLayout").val() == 2) {
        $('.auto').css('display', 'none');
        $('.manualGallery').css('display', 'block');
        $('.manualSpeakerl').css('display', 'none');
    }
    if ($("#chooseLayout").val() == 3) {
        $('.auto').css('display', 'none');
        $('.manualGallery').css('display', 'none');
        $('.manualSpeakerl').css('display', 'block');
    }
})

$('.settingLayout').on('click', 'img', (event) => {
    var target = $(event.target);
    $(".setUserLayout_left img")[0].src = target[0].src;
})

var currentLayoutModelItems = [];

function bindLayout(coordinate) {
    var layout = {
        userId: '',
        deviceId: '',
        x: coordinate.x,
        y: coordinate.y,
        w: coordinate.w,
        h: coordinate.h,
        zorder: coordinate.zorder
    }

    return layout;
}
$('.settingLayout').on('click', 'input', (event) => {
    var target = $(event.target);

    if (target[0].value != '自动画廊' && target[0].value != '自动演讲者') {
        for (var i in layoutModels) {
            if (target[0].value == layoutModels[i].modelName) {
                for (var j = 0; j < layoutModels[i].modelNum; j++) {
                    currentLayoutModelItems.push(bindLayout(layoutModels[i].coordinate[j]));
                }
                console.log('=====================', currentLayoutModelItems)
            }
        }
    }

    $(".setUserLayout_left img")[0].src = $('.' + target[0].id)[0].src;
    if (target[0].value == '3分屏') {
        $('.chooseUser3').css('display', 'block');
        $('.chooseUser4').css('display', 'none');
        $('.screenShow').css('display', 'none');
        currentLayoutModelType = 1;

        for (var i = 0; i < $('.chooseUser3').children().length; i++) {
            var selected = $('.chooseUser3').children()[i].id;
            currentLayoutModelItems[i].userId = $('#' + selected + ' ' + 'option:selected')[0].id;
            currentLayoutModelItems[i].deviceId = $('.chooseUser3').children()[i].value;
        }

    } else if (target[0].value == '4分屏' || target[0].value == '手动演讲者1' || target[0].value == '手动演讲者2') {
        $('.chooseUser3').css('display', 'none');
        $('.chooseUser4').css('display', 'block');
        $('.screenShow').css('display', 'none');
        currentLayoutModelType = 1;

        for (var i = 0; i < $('.chooseUser4').children().length; i++) {
            var selected = $('.chooseUser4').children()[i].id;
            currentLayoutModelItems[i].userId = $('#' + selected + ' ' + 'option:selected')[0].id;
            currentLayoutModelItems[i].deviceId = $('.chooseUser4').children()[i].value;
        }

    } else if (target[0].value == '自动演讲者') {
        $('.screenShow').css('display', 'block');
        $('.chooseUser3').css('display', 'none');
        $('.chooseUser4').css('display', 'none');
        currentLayoutModelType = 3;
    } else if (target[0].value == '自动画廊') {
        $('.chooseUser').css('display', 'none');
        $('.screenShow').css('display', 'none');
        currentLayoutModelType = 2;
    }

})

//创建合屏
function createAvc() {
    restApi.startAvcScreenModel(self.accessToken, roomId).then((res) => {
        console.log("=============================startAvcScreenModel()", res)
    }).otherwise((error) => {
        $('.promptMsg').html("createScreen(),error:" + error);
    })
}

//停止合屏
function stopScreen() {
    restApi.stopAvcScreenModel(self.accessToken, roomId).then((res) => {
        console.log("=============================stopAvcScreenModel()", res)
    }).otherwise((error) => {
        $('.promptMsg').html("stopScreen(),error:" + error);
    })
}

//观看合屏
function watchScreen() {

}

//保存布局
function saveLayout() {

}

