var AppEnum = require('/utils/enum.js');
var api = require('/restApi/api.js');
var config = require('/config.js');

App({
  data: {

    //avdSDK是引用小程序SDK的全局变量，请保证变量名不变
    avdSDK: {
      avdSDKInstance:null,
      restfulServer: null,
      Enum: null,
      Util: null,
      avdEngine: null,
      room: null,
      serverInfo: {},
      client: null,
      signalClient: null,
      Task_Id: 0,
      appIsOnShow: true
    },

    accessToken: '',
    
    userInfo: {
      webChatId: '',
      webChatName: '',
      params: {
        businessCode: '',
        sortValue: ''
      }
    },

    config: config,
    
    callInvite: null,
  },


  /**
   * 生命周期函数--监听小程序初始化 当小程序初始化完成时，会触发 onLaunch（全局只触发一次）
   */
  onLaunch: function(options) {
    console.log("app.js ---onLaunch---");

    var self = this;
    
    //改进JSON.stringify方法，原因JSON.stringify处理循环引用对象会报错TypeError: Converting circular structure to JSON
    var handleCircular = function () {
      var cache = [];
      var keyCache = []
      return function (key, value) {
        if (typeof value === 'object' && value !== null) {
          var index = cache.indexOf(value);
          if (index !== -1) {
            return '[Circular ' + keyCache[index] + ']';
          }
          cache.push(value);
          keyCache.push(key || 'root');
        }
        return value;
      }
    }

    var tmp = JSON.stringify;
    JSON.stringify = function (value, replacer, space) {
      replacer = replacer || handleCircular();
      return tmp(value, replacer, space);
    }

 
    /**
     * 引用SDK的方式
     */
    console.log("当前引用SDK版本:cn.tee3.wxavd1.1.7.js");
    var avdSDK = require('/lib/cn.tee3.wxavd1.1.7.js');

    self.data.avdSDK.avdSDKInstance = avdSDK;
    self.data.avdSDK.restfulServer = new avdSDK.RestfulServer();
    self.data.avdSDK.Enum = avdSDK.Enum;
    self.data.avdSDK.Util = avdSDK.Util;

  },

  /**
   * 生命周期函数--监听小程序显示 当小程序启动，或从后台进入前台显示，会触发 onShow
   */
  onShow: function() {
    console.log("app.js ---onShow---");
    this.data.avdSDK.appIsOnShow = true;
  },


  /**
   * 生命周期函数--监听小程序隐藏 当小程序从前台进入后台，会触发 onHide
   */
  onHide: function() {
    console.log("app.js ---onHide---");
    this.data.avdSDK.appIsOnShow = false;
  },

  /**
   * 错误监听函数 当小程序发生脚本错误，或者 api 调用失败时，会触发 onError 并带上错误信息
   */
  onError: function(msg) {
    console.log("app.js ---onError---" + msg);
  },
})