
//获取应用实例
const app = getApp();

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		roomId: '',
		trumpet: false,

		livePusherIsLarge: false,
		livePlayerIsLarge: true,

    callDuration: 0,
    intervalTimer: null,
    timeConent: "00:00",

    isReceiveInviteClose: false,
    isCallInviteClose:false,
  
    judgeParticipantsNumTimer: null,

		player: {
			userId: '',
			userName: '',
			head: '',
			playUrlMain: '',
			playUrlAssist: '',
			videoPlaying: false,
			audioPlaying: false,
			isPub: false,
			pubCameraId: ""
		},

		pusher: {
			userId: '',
			userName: '',
			url: '', //推流地址。目前仅支持 flv, rtmp 格式
			muted: true, //是否静音
			enableCamera: false, //开启摄像头
			autoFocus: true, //自动聚集
			orientation: "vertical", //vertical，horizontal
			beauty: 6.3, //美颜
			whiteness: 0, //美白
			aspect: "9:16", //宽高比，可选值有 3:4, 9:16	
			minBitrate: 500, //最小码率
			maxBitrate: 1000, //最大码率
			waitingImage: '', //进入后台时推流的等待画面	
			waitingImageHash: '', //等待画面资源的MD5值	
			backgroundMute: false, //进入后台时是否静音

			pusherContext: '',
			classValue: 'large-live',
			frontCamera: true, //开启前置摄像头
			videoPlaying: false,
			audioPlaying: false,

			audioOpenState: false,
			videoOpenState: false,
		},
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		this.participantsHandle(app.data.avdSDK.room.getParticipants());
		this.registerRoomCallback();

    this.registerClientCallback();

		this.data.pusher.userId = app.data.avdSDK.room.selfUser.id;
		this.data.pusher.userName = app.data.avdSDK.room.selfUser.name;
		this.data.pusher.url = '';
		this.data.pusher.minBitrate = app.data.avdSDK.room.selfUser.pusherMinBitrate;
		this.data.pusher.maxBitrate = app.data.avdSDK.room.selfUser.pusherMaxBitrate;
		this.data.audioOpenState = options.audioOpenState == 'true' ? true : false;
		this.data.videoOpenState = options.videoOpenState == 'true' ? true : false;

		this.setData({
			  roomId: app.data.avdSDK.room.id,
		  	pusher: this.data.pusher
		});
    
    if(app.data.callInvite){
       app.data.callInvite.addCallback(app.data.avdSDK.Enum.InviteCallbackEnum.CALL_CLOSE_NOTIFY, this.onCallClose);
    }
    this.judgeParticipantsNum();
	},

  //判断参会者数
  judgeParticipantsNum(){
    var a = 0;
    var self = this;

    self.judgeParticipantsNumTimer = setInterval(function () {
      console.log(new Date(),'judgeParticipantsNum(),getParticipants().length:', app.data.avdSDK.room.getParticipants().length);
      
      if(app.data.avdSDK.room.getParticipants().length >1){
      	  clearInterval(self.judgeParticipantsNumTimer);
      	  return;
      }else if(a >= 15  &&  !self.isReceiveInviteClose) {
          clearInterval(self.judgeParticipantsNumTimer);
          wx.showModal({
            title: '提示',
            content: '座席端已挂断',
            showCancel: false,
            success(res) {
              if (res.confirm) {
                self.leaveRoom();
              }
            }
          })
          return;
      }else{
         a += 1;
      }
    }, 1000)

  },


  /**
  * 注册Client级别回调 
  */
  registerClientCallback: function () {
    app.data.avdSDK.client.addCallback(app.data.avdSDK.Enum.ClientCallbackEnum.MQTT_CONNECT_STATE, this.onMqttConnectState);
  },

  //MQTT 连接状态显示
  onMqttConnectState: function (state) {
    console.log("=======================onMqttConnectState(),state:", state);
    if (state == app.data.avdSDK.Enum.mqttConnectStateEnum.connect) {
      wx.hideLoading();
    } else if (state == app.data.avdSDK.Enum.mqttConnectStateEnum.reconnect) {
      wx.showLoading({
        title: '路由重连中...',
        mask: true
      });
    } else {
      wx.hideLoading();
    }
  },



  //RPC通知回调
  onRpcNotification: function (data) {
    console.log(new Date(), "onRpcNotification(), data :", data);
    if (data.type == "error") {
      var error = {};
      error.code = data.error.code;
      error.message = data.error.message;
      this.setTipsMessageError(error);
    } else {
      this.setTipsMessage(data);
    }
  },


  //收到远端邀请挂断
  onCallClose: function (fromUserId, reson) {
    var self = this;
    console.log(new Date(),"======home.js,  onCallClose()=====fromUserId:" + fromUserId + ";reson:" + reson);
    
    this.isReceiveInviteClose = true;
    
    if(self.judgeParticipantsNumTimer){
       clearInterval(self.judgeParticipantsNumTimer);
    }
    
    wx.showModal({
      title: '提示',
      content: '座席端已挂断',
      showCancel: false,
      success(res) {
        if (res.confirm) {
          self.leaveRoom();
        }
      }
    })
  },


	/**
	 * 生命周期函数--监听页面初次渲染完成
	 */
	onReady: function () {
		var self = this;
		self.createPusherContext();

    self.enableCameraClick();
    self.muteClick();

    this.counter();

    setTimeout(function(){
      wx.showToast({
        title: '已接通',
        icon: 'none',
        duration: 2000
      })
    },500)

		//保持屏幕常亮，做到手机不锁屏
		wx.setKeepScreenOn({
			keepScreenOn: true
		})
	},

	//注册房间回调
	registerRoomCallback: function () {
		console.log(new Date(), "registerRoomCallback()");
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.connection_status, this.onConnectionStatus);
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_join_notify, this.onUserJoinNotify);
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_leave_notify, this.onUserLeaveNotify);
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.leave_indication, this.onLeaveIndication);
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.close_room_result, this.onCloseRoomResult);
		app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.close_room_notify, this.onCloseRoomNotify);

		app.data.avdSDK.room.setRoomCallbackMonitorState2True();
	},

	/**
	 * @desc  用户回调事件
	 * @param {Object} participants - 用户集数组
	 */
	participantsHandle: function (participants) {
		console.log(new Date(), "============participantsHandle=========", participants);
		var self = this;
		participants.forEach(function (user) {
			user.addCallback(app.data.avdSDK.Enum.UserCallback.microphone_status_notify, self.onMicrophoneStatusNotify);
			user.addCallback(app.data.avdSDK.Enum.UserCallback.camera_status_notify, self.onCameraStatusNotify);


			user.addCallback(app.data.avdSDK.Enum.UserCallback.publish_camera_notify, self.onPublishCameraNotify);
			user.addCallback(app.data.avdSDK.Enum.UserCallback.unpublish_camera_notify, self.onUnpublishCameraNotify);
			user.addCallback(app.data.avdSDK.Enum.UserCallback.subscrible_camera_result, self.onSubscribleCameraResult);
			user.addCallback(app.data.avdSDK.Enum.UserCallback.unsubscrible_camera_result, self.onUnsubscribleCameraResult);

			user.addCallback(app.data.avdSDK.Enum.UserCallback.subscrible_microphone_result, self.onSubscribleMicrophoneResult);
			user.addCallback(app.data.avdSDK.Enum.UserCallback.unsubscrible_microphone_result, self.onUnsubscribleMicrophoneResult);

			if (user.id != app.data.avdSDK.room.selfUser.id) {

				self.data.player.userId = user.id;
				self.data.player.userName = user.name;
				self.data.player.head = user.name.charAt(0);
				self.data.player.playUrlMain = '';
				self.data.player.playUrlAssist = '';
				self.data.player.videoPlaying = false;
				self.data.player.audioPlaying = false;
				self.data.player.isPub = false;
				self.data.player.pubCameraId = '';

				self.data.pusher.classValue = 'small-live';

				self.setData({
					player: self.data.player,
					pusher: self.data.pusher,
				});
			}
		});

		app.data.avdSDK.room.setUserCallbackMonitorState2True();
	},



	/**
	 * 切换视频状态事件
	 */
	enableCameraClick: function () {
		var self = this;
		console.log(new Date(), "=====enableCameraClick=====");

		if (self.data.pusher.enableCamera) {
      wx.showLoading({
        title: '正在关闭摄像头...',
        mask: true
      })
			app.data.avdSDK.room.selfUser.videos[0].unpublish().then(() => {
				self.data.pusher.enableCamera = false;
				self.data.pusher.videoPlaying = false;
				self.setData({
					pusher: self.data.pusher
				});
				wx.hideLoading()

				if (self.data.pusher.audioPlaying) {
					self.data.pusher.pusherContext.stop();
					setTimeout(() => {
						self.data.pusher.pusherContext.start();
					}, 500)
				}

			}).catch((error) => {
        console.log(new Date(), "取消发布视频出错提示:", error);

				wx.hideLoading()
				wx.showModal({
					title: '取消发布视频出错提示',
					content: error.message + "[" + error.code + "]",
					showCancel: false
				})

			});
		} else {
			wx.showLoading({
				title: '正在打开摄像头...',
				mask: true
			})
			app.data.avdSDK.room.selfUser.videos[0].publish().then(() => {
				self.data.pusher.enableCamera = true;
				self.data.pusher.videoPlaying = true;
				self.data.pusher.url = app.data.avdSDK.room.selfUser.pusherUrl;
				self.setData({
					pusher: self.data.pusher
				});
				wx.hideLoading()

				self.data.pusher.pusherContext.stop();
				setTimeout(() => {
					self.data.pusher.pusherContext.start();
				}, 500)
				console.log(new Date(), "发布视频成功:", self.data.pusher);
      }).catch((error) => {
        console.log(new Date(), "发布视频出错,error:", error.message + "[" + error.code + "]");
				wx.hideLoading();

				wx.showModal({
					title: '发布视频出错提示',
          content: "网络异常,稍后再试。[code:10003]",
					showCancel: false
				})
			});
		}
	},

	/**
	 * 切换音频状态事件
	 */
	muteClick: function () {
		var self = this;
		console.log(new Date(), "=====muteClick=====");

		if (!self.data.pusher.muted) {
      wx.showLoading({
        title: '正在关闭音频...',
        mask: true
      })
			app.data.avdSDK.room.selfUser.audio.unpublish().then(() => {
				self.data.pusher.muted = true;
				self.data.pusher.audioPlaying = false;
				self.setData({
					pusher: self.data.pusher
				});
				wx.hideLoading();
      }).catch((error) => {
        console.log(new Date(), "取消发布音频出错提示:", error);
				wx.hideLoading()
				wx.showModal({
					title: '取消发布音频出错提示',
					content: error.message + "[" + error.code + "]",
					showCancel: false
				})
			});
		} else {
			wx.showLoading({
				title: '正在打开音频...',
				mask: true
			})

			app.data.avdSDK.room.selfUser.audio.publish().then(() => {
				self.data.pusher.muted = false;
				self.data.pusher.audioPlaying = true;
				self.data.pusher.url = app.data.avdSDK.room.selfUser.pusherUrl;
				self.setData({
					pusher: self.data.pusher
				});

				wx.hideLoading()

				if (!self.data.pusher.enableCamera) {
					self.data.pusher.pusherContext.stop();
					setTimeout(() => {
						self.data.pusher.pusherContext.start();
					}, 500)
				}
				console.log(new Date(), "发布音频成功:", self.data.pusher);
      }).catch((error) => {
        console.log(new Date(), "发布音频出错,error:", error.message+"["+error.code + "]");
				wx.hideLoading()
        
				wx.showModal({
					title: '发布音频出错提示',
          content: "网络异常,稍后再试。[code:10003]",
					showCancel: false
				})
			});
		}
	},

	createPusherContext: function () {
		var self = this;
		if (!self.data.pusher.pusherContext) {
			self.data.pusher.pusherContext = wx.createLivePusherContext(self.data.pusher.userId + "_pusher");
		}
	},


	//挂断
  hangUp: function () {
    var self = this;

    wx.showLoading({
      title: '挂断中...',
      mask: true
    });


    if (app.data.callInvite){
        app.data.callInvite.close("hangUp").then(function(){
           self.isCallInviteClose= true;
           self.leaveRoom();
           console.log(new Date,"==============home.js,hangUp(), callInvie = true,wx.hideLoading..");
           wx.hideLoading();
        });
    }else{
       console.log(new Date, "==============home.js,hangUp(), callInvie = false,wx.hideLoading..");
       wx.hideLoading();
    }
  
	},


  leaveRoom: function(){
     var self = this;
     clearInterval(self.intervalTimer);

     var reason = 1; //退会原因
     if (app.data.avdSDK.room){
       app.data.avdSDK.room.leave(reason).then(function () {
         self.logout(reason);
       });
     }
  },




  //登出到touch页面
  //reason：登出原因
  logout: function (reason) {
    if (app.data.avdSDK && app.data.avdSDK.client){
       app.data.avdSDK.client.logout(reason).then(function () {
        var url = "../touch/touch";
        wx.reLaunch({
          url: url
        });
      });
    }
  },


	/**
	 * 扬声器状态改变
	 */
	trumpetClick: function () {
		console.log(new Date(), "=====trumpetClick=====");
		var self = this;
		this.setData({
			trumpet: !self.data.trumpet
		});
	},


	/**
	 * 切换前后置摄像头
	 */
	switchCameraClick: function () {
		console.log(new Date(), "=====switchCameraClick=====");
		var self = this;
		self.data.pusher.frontCamera = !self.data.pusher.frontCamera;
		self.setData({
			pusher: self.data.pusher
		})
		self.data.pusher.pusherContext.switchCamera();
	},

	//网络状态
	onConnectionStatus: function (status) {
		console.log(new Date(), "----------onConnectionStatus----------")
    var self = this;
		if (status == app.data.avdSDK.Enum.ConnectionStatus.connecting) {
			wx.showLoading({
				title: '会议重连中...',
				mask: true
			})
		} else if (status == app.data.avdSDK.Enum.ConnectionStatus.connected || status == app.data.avdSDK.Enum.ConnectionStatus.reconnected) {
			this.startFun();
			wx.hideLoading()
		} else if (status == app.data.avdSDK.Enum.ConnectionStatus.connectFailed) {
			wx.showLoading({
				title: '重新加会中...',
				mask: true
			})
		} else if (status == app.data.avdSDK.Enum.ConnectionStatus.reJoinConnected) {
			this.startFun();
			wx.hideLoading()
		} else if (status == app.data.avdSDK.Enum.ConnectionStatus.reJoinRoomTimeOut) {

			wx.showModal({
				title: '重新加会失败',
				showCancel: false,
				success: function (res) {
					if (res.confirm) {
						var reason = 1; //退会原因
						app.data.avdSDK.room.leave(reason).then(function () {
              self.logout(reason);
						});
					} else if (res.cancel) {

					}
				}
			})
		}
	},

	startFun: function () {
		if (this.data.pusher.pusherContext && this.data.pusher.url) {
			this.data.pusher.pusherContext.start();
		}
		if (this.data.player.userId) {
			wx.createLivePlayerContext("largePlay").play();
		}
	},

	/**
	 * @desc 参会者加会回调
	 * @param {Object} users － 参会者数组
	 */
	onUserJoinNotify: function (users) {
		console.log(new Date(), "======onUserJoinNotify========");
		if(this.judgeParticipantsNumTimer){
          clearInterval(this.judgeParticipantsNumTimer);
    }
		
		this.participantsHandle(users);
	},


	/**
	 * @desc 参会者退会回调
	 * @param {int} opt - 退会类型
	 * @param {int} reason  - 退会原因
	 * @param {Object} user - 退会用户
	 */
	onUserLeaveNotify: function (opt, reason, user) {
    var self = this;
    console.log(new Date(), "======onUserLeaveNotify========reason:", reason,",user:",user);

    //用户异常离会(用户心跳包超时掉线)
    if(reason == 812) {
    	if(self.judgeParticipantsNumTimer){
          clearInterval(self.judgeParticipantsNumTimer);
      }
 
      wx.showModal({
        title: '提示',
        content: '座席端已异常离会，本地挂断处理',
        showCancel: false,
        success(res) {
          if (res.confirm) {
            self.hangUp();
          }
        }
      })
      return;
    } else {
      console.log(new Date(), "======onUserLeaveNotify========正常离会");
      if (self.judgeParticipantsNumTimer) {
         clearInterval(self.judgeParticipantsNumTimer);
      }

      setTimeout(function(){
        console.log(new Date(), "======onUserLeaveNotify========正常离会，setTimeout（）...");
        if (!self.isReceiveInviteClose && !self.isCallInviteClose){
          wx.showModal({
            title: '提示',
            content: '座席端已挂断',
            showCancel: false,
            success(res) {
              if (res.confirm) {
                self.leaveRoom();
              }
            }
          })
        }
      },8000);
     
    }
		
		self.data.player.userId = '';
		self.data.player.userName = '';
		self.data.player.head = '';
		self.data.player.playUrlMain = '';
		self.data.player.playUrlAssist = '';
		self.data.player.videoPlaying = false;
		self.data.player.audioPlaying = false;
		self.data.player.isPub = false;
		self.data.player.pubCameraId = '';

		self.data.pusher.classValue = 'large-live';

		self.setData({
			player: self.data.player,
			pusher: self.data.pusher,
		});

		wx.createLivePlayerContext("largePlay").stop();
	},


	/**
	 * @desc 被踢出会议室
	 * @param {Object} reason - 被踢原因
	 * @param {Object} userId - 踢人的操作者
	 */
	onLeaveIndication: function (reason, userId) {
		console.log(new Date(), "======onLeaveIndication========");
    var self = this;
		var user = getApp().data.avdSDK.room.getUser(userId);
		var userName = '';
		if (user != null) {
			 userName = user.name;
		}

		if (reason == 804) { //同一个userid加会， 把前一个人踢下线
			wx.showModal({
				title: '退会提示',
				content: '您已在另一终端登陆，被踢出会议室。被踢原因：' + reason,
				showCancel: false
			});

		} else if (reason == 808) { //调用rest api接口把人踢下线
			wx.showModal({
				title: '退会提示',
				content: '您被' + userName + '踢出会议室。被踢原因：' + reason,
				showCancel: false
			});

		} else if (reason == 809) { //无授权 15分钟以后强制踢人
			wx.showModal({
				title: '退会提示',
				content: '无授权，试用时限到期，您被' + userName + '踢出会议室。被踢原因：' + reason,
				showCancel: false
			});

		} else {
			wx.showModal({
				title: '退会提示',
				content: '您已被主持人从会议中踢出',
				showCancel: false
			});
		}
    
    clearInterval(this.intervalTimer);

		setTimeout(function () {
      self.logout(0);
			return false;
		}, 5000);

	},


	/**
	 * @desc 关闭会议回调结果
	 * @param {int} result - 关闭结果
	 * @param {String} description - 描述
	 */
	onCloseRoomResult: function (result, description) {
		console.log(new Date(), "======onCloseRoomResult========");
    var self = this;
		if (result == 0) {
      self.logout(0);
			return false;
		} else {
			wx.showModal({
				title: '关闭会议提示',
				content: '关闭会议异常。原因：' + description + '[' + result + ']',
				showCancel: false
			});
		}
	},


	/**
	 * @desc 收到主持人关闭房间通知，退出会议操作
	 * @param {int} roomId - 房间ID
	 * @param {int} reason  -关闭会议原因
	 */
	onCloseRoomNotify: function (roomId, reason) {
		console.log(new Date(), "======onCloseRoomNotify========");
    var self = this;
		if (reason == 810) {
			wx.showModal({
				title: '关闭会议提示',
				content: '主持人已关闭会议。',
				showCancel: false
			});

			setTimeout(function () {
				var reason = 1; //退会原因
				app.data.avdSDK.room.leave(reason).then(function () {
          self.logout(reason);
					return false;
				});
			}, 2000);

		}
	},



	/**
	 * 麦克风状态更新
	 * @param {Object} status － 状态
	 * @param {Object} microphoneId － 麦克风设备Id 
	 * @param {Object} microphoneName － 麦克风设备名称
	 * @param {Object} userId － 麦克风设备所属者ＩＤ
	 */
	onMicrophoneStatusNotify: function (status, microphoneId, microphoneName, userId) {
    console.log(new Date(), "======onMicrophoneStatusNotify,userId:", userId + ',status:', status);
	},

	/**
	 * 摄像头状态更新
	 * @param {Object} status － 状态
	 * @param {Object} cameraId － 摄像头设备Id
	 * @param {Object} cameraName－ 摄像头设备名称
	 * @param {Object} userId－ 摄像头设备所属者ＩＤ
	 */
	onCameraStatusNotify: function (status, cameraId, cameraName, userId) {
    console.log(new Date(), "======onCameraStatusNotify,userId:", userId + ',status:', status);

	},

	//订阅未订阅的视频
	onPublishCameraNotify: function (videos) {
		console.log(new Date(), "======onPublishCameraNotify========");
		var self = this;
		console.log(new Date(), "+++++++++++++++++++videos:", videos);
		videos.forEach(function (video) {

			//只订阅未订阅过的视频
			var subVideoIdsLen = getApp().data.avdSDK.room.selfUser.subVideoIds.length;
			if (subVideoIdsLen > 0) {
				var isSub = false;
				for (var i = 0; i < subVideoIdsLen; i++) {
					var videoId = getApp().data.avdSDK.room.selfUser.subVideoIds[i];
					if (video.id == videoId) {
						isSub = true;
						break;
					}
				}
				if (!isSub) {
					console.log(new Date(), "++++++++++++isSub=false,video.playerUrl:", video.playerUrl);

					console.log(new Date(), '++++isSub=false,订阅视频通知Subscrible');
					video.subscrible().catch((error) => {
						console.log("video.subscrible(),error:", error);
					});

					self.data.player.isPub = true;
					self.data.playUrlMain = video.playerUrl;
					self.data.pubCameraId = video.id;
					self.setData({
						player: self.data.player
					});
				}
			} else {
				console.log(new Date(), "++++++++++++isSub=true,video.playerUrl:", video.playerUrl);

				console.log(new Date(), '++++isSub=true,订阅视频通知Subscrible');
				video.subscrible().catch((error) => {
					console.log("video.subscrible(),error:", error);
				});

				self.data.player.isPub = true;
				self.data.player.playUrlMain = video.playerUrl;
				self.data.player.pubCameraId = video.id;
				self.setData({
					player: self.data.player
				});
			}
		});
	},

	onUnpublishCameraNotify: function (video) {
		console.log(new Date(), "======onUnpublishCameraNotify========");
		var self = this;
		video.unsubscrible();

		self.data.player.isPub = false;
		self.setData({
			player: self.data.player
		});

	},

	/**
	 * 订阅远端视频流反馈
	 * @param {Object} userId － 所属用户ＩＤ
	 * @param {Object} userName－ 所属用户名称
	 * @param {Object} cameraId－ 摄像头设备ＩＤ
	 */
	onSubscribleCameraResult: function (userId, userName, cameraId) {
    console.log(new Date(), "======onSubscribleCameraResult========");
		var self = this;

		self.data.player.videoPlaying = true;
		self.setData({
			player: self.data.player,
			livePusherIsLarge: false,
			livePlayerIsLarge: true
		});
	},

	/**
	 * 取消订阅远端视频流反馈
	 * @param {Object} userId－ 所属用户ＩＤ
	 * @param {Object} userName－所属用户名称
	 * @param {Object} cameraId－摄像头设备ＩＤ
	 */
	onUnsubscribleCameraResult: function (userId, userName, cameraId) {
		console.log(new Date(), "======onUnsubscribleCameraResult========");
		var self = this;

		self.data.player.videoPlaying = false;
		self.setData({
			player: self.data.player,
			livePusherIsLarge: true,
			livePlayerIsLarge: false
		});
	},

	/**
	 * 订阅远端音频流反馈
	 * @param {Object} stream－ 远端音频流
	 * @param {Object} userId－ 所属用户ＩＤ
	 * @param {Object} userName－所属用户名称
	 */
	onSubscribleMicrophoneResult: function (userId, userName, microphoneId) {
		console.log(new Date(), "======onSubscribleMicrophoneResult========");

		var self = this;

		var user = getApp().data.avdSDK.room.getUser(userId);
		self.data.player.playUrlAssist = user.audio.playerUrl;

		console.log(new Date(), "++++++++++++ser.audio.playerUrl:", user.audio.playerUrl);

		self.data.player.audioPlaying = true;

		self.setData({
			player: self.data.player
		});
	},

	/**
	 * 取消订阅远端音频流反馈
	 * @param {Object} userId－ 所属用户ＩＤ
	 * @param {Object} userName－所属用户名称
	 */
	onUnsubscribleMicrophoneResult: function (userId, userName, microphoneId) {
		console.log(new Date(), "======onUnsubscribleMicrophoneResult========");
		var self = this;
		self.data.player.audioPlaying = false;
		self.setData({
			player: self.data.player
		});
	},


  //会议时长计数器
  counter:function(){
    var self = this;
    
    console.log("================counter()，init");
    self.intervalTimer = setInterval(function () {
      self.data.callDuration++;
      var minuteCount = parseInt(self.data.callDuration / 60);
      var secondNum = self.data.callDuration % 60;

      if (minuteCount < 10) {
        minuteCount = "0" + minuteCount;
      }
      if (secondNum < 10) {
        secondNum = "0" + secondNum;
      }
      var timeConent = minuteCount + ":" + secondNum;
      self.setData({
        timeConent: timeConent
      });

    }, 1000);
  },

  onPushEvent: function (e) {
    var self = this;
    return;
    self.createPusherContext();

    var code;
    if (e.detail) {
      code = e.detail.code;
    } else {
      code = e;
    }

    var errmessage = '';
    switch (code) {
      case 1002:
        break;

      case -1301:
        console.error('打开摄像头失败: ', code);
        break;

      case -1302:
        console.error('打开麦克风失败: ', code);
        break;

      case -1307:
        console.error('推流连接断开: ', code);

        // this.pusherStop();
        wx.showToast({
          title: '推流连接断开',
        })
        break;

      default:
      // console.log('推流情况：', code);

    }

  },

  onPushStatus: function (e) {
    // console.log("=========push status start===============");
    // console.log("videoBitrate:", e.detail.info.videoBitrate, "kbps");
    // console.log("videoFPS:", e.detail.info.videoFPS, "帧");
    // console.log("resolution:", e.detail.info.videoWidth, "x", e.detail.info.videoHeight);

    // console.log("audioBitrate:", e.detail.info.audioBitrate, "kbps");
    // console.log("网络抖动情况:", e.detail.info.netJitter);
    // console.log("=========push status end===============");
  },

  onPushError: function (e) {
    console.log('推流错误：', e);
    e.detail.errCode == 10001 ? (e.detail.errMsg = '未获取到摄像头功能权限，请删除小程序后重新打开') : '';
    e.detail.errCode == 10002 ? (e.detail.errMsg = '未获取到录音功能权限，请删除小程序后重新打开') : '';

    wx.showToast({
      title: e.detail.errMsg || '未获取到摄像头、录音功能权限，请删除小程序后重新打开',
    })

  },

  onPlayStatus: function (e) {
    // console.log(new Date(), "=========play status start===============");
    // console.log(new Date(), "videoBitrate:", e.detail.info.videoBitrate, "kbps");
    // console.log("videoFPS:", e.detail.info.videoFPS, "帧");
    // console.log("resolution:", e.detail.info.videoWidth, "x", e.detail.info.videoHeight);

    // console.log("audioBitrate:", e.detail.info.audioBitrate, "kbps");
    // console.log("网络抖动情况:", e.detail.info.netJitter);
    // console.log("=========play status end===============");
  },


  onPlayEvent: function (error) {
    if (error.detail.code < 0) {
      console.error('拉流失败:', error.detail.code + "," + error.detail.message);
    } else {
      //console.log('拉流情况:', error.detail.code + "," + error.detail.message);
    }
  },


	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
    console.log("home.js---onShow");
   
    /**
     * 小程序接电话后或从应用后台切换前台时，通过判断socket的状态来决定关闭页面
     * 注：华为，vivo接电话及切换到后台websocket会断
     *    小米、iphone接电话websocket正常； 切换到后台websocket会断
    */
    var readyState = getApp().data.avdSDK.room.socketManager.readyState();
    if (readyState == 3) {
      console.log("home.js---onShow(),socketState==3,to leaveRoom()");
      this.leaveRoom();
    }

	},

	/**
	 * 生命周期函数--监听页面隐藏
	 */
	onHide: function () {
    console.log("home.js---onHide");
	},

	/**
	 * 生命周期函数--监听页面卸载
	 */
	onUnload: function () {
    console.log("home.js---onUnload");
	},

	/**
	 * 页面相关事件处理函数--监听用户下拉动作
	 */
	onPullDownRefresh: function () {

	},

	/**
	 * 页面上拉触底事件的处理函数
	 */
	onReachBottom: function () {

	},

	/**
	 * 用户点击右上角分享
	 */
	onShareAppMessage: function () {

	}
})